/*
 * Created on Jun 30, 2005 Copyright (c) 2005 Nooto Poject. All rights reserved.
 */
package note.command;

import java.lang.reflect.Method;

import javax.swing.undo.AbstractUndoableEdit;

import note.NoteApplication;
import note.RegisteredPictureMap;
import note.control.NoteApplicationMode;
import note.control.Pen;
import note.model.Note;
import note.model.Page;
import note.model.PictureGroup;
import note.model.TextGroup;
import note.viewer.GroupEditor;
import note.viewer.NoteProcessorPane;
import note.viewer.PageViewer;
import note.viewer.PictureGroupPane;
import note.viewer.TextGroupPane;

/**
 * Class AbstractCommand<br>
 * R}h̒ۃNXB<br>
 * <br>
 * hNXclone邱ƁB<br>
 * Undoable ɂꍇ́Aundo,redo\bhI[o[Ch邱ƁB<br>
 * 
 * @see javax.swing.undo.AbstractUndoableEdit
 * 
 * @author camei
 * @version $Id: AbstractCommand.java,v 1.11 2006/01/31 00:52:00 camei Exp $
 */
public abstract class AbstractCommand extends AbstractUndoableEdit implements
		Cloneable {

	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	private NoteApplication reciever;

	/***************************************************************************
	 * \bh
	 **************************************************************************/
	/**
	 * RXgN^
	 */
	protected AbstractCommand() {
	}

	/**
	 * RXgN^
	 * 
	 * @param reciever R}h̑Ώ
	 */
	public AbstractCommand(NoteApplication reciever) {
		this.reciever = reciever;
	}

	/**
	 * N[B<br>
	 * s邽߂̃R}h̃N[߂B<br>
	 * Undô߂ɕKR}h̓N[Ăs邱ƁB<br>
	 * 
	 * @return ̃R}h̃N[߂B
	 */
	public abstract Object clone();

	/**
	 * @return ̃R}hݎs\ǂ
	 */
	public abstract boolean canExecute();
	
	/**
	 * ̃R}hsB<br>
	 * canExecute()falsȅꍇACannotExecuteExceptionX[B
	 */
	public void execute() {
		if (!canExecute()) {
			throw new CannotExecuteException();
		}
	}
	
	/**
	 * ̃R}hsB
	 */
	public void executeToApplication() {
		if (canExecute()) {// s\ȏꍇ
			reciever.executeCommand(this);
		}
	}

	/***************************************************************************
	 * static \bh
	 **************************************************************************/
	/**
	 * @param reciever V[o
	 * @return UndoR}h
	 */
	public static AbstractCommand createUndoCommand(NoteApplication reciever) {
		try {
			Method method = NoteApplication.class.getDeclaredMethod("undo",
					null);
			return new SimpleCommand(reciever, reciever, method);

		} catch (SecurityException e) {
			// TODO ꂽ catch ubN
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			// TODO ꂽ catch ubN
			e.printStackTrace();
		}
		return null;
	}

	/**
	 * @param reciever V[o
	 * @return RedoR}h
	 */
	public static AbstractCommand createRedoCommand(NoteApplication reciever) {
		try {
			Method method = NoteApplication.class.getDeclaredMethod("redo",
					null);
			return new SimpleCommand(reciever, reciever, method);

		} catch (SecurityException e) {
			// TODO ꂽ catch ubN
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			// TODO ꂽ catch ubN
			e.printStackTrace();
		}
		return null;

	}

	/***************************************************************************
	 * Undo Redo
	 **************************************************************************/
	/**
	 * \ǂ߂B<br>
	 * invoker̖͂߂lUndoableManagerɓo^邩ǂ𔻒fB
	 * 
	 * @return \ǂ
	 */
	public abstract boolean isUndoableEdit();

	/**
	 * ƂɃ[U[ɒ񎦂eLXg߂B<br>
	 * fBtHgł getPresentationName() ̓e߂B
	 * 
	 * @return ƂɃ[U[ɒ񎦂eLXg߂B
	 * @see javax.swing.undo.AbstractUndoableEdit#getRedoPresentationName()
	 * @see javax.swing.undo.AbstractUndoableEdit#getPresentationName()
	 */
	public String getRedoPresentationName() {
		return getPresentationName();
	}

	/**
	 * ɖ߂ƂɃ[U[ɒ񎦂eLXg߂B<br>
	 * fBtHgł getPresentationName() ̓e߂B
	 * 
	 * @return ɖ߂ƂɃ[U[ɒ񎦂eLXg߂B
	 * @see javax.swing.undo.AbstractUndoableEdit#getUndoPresentationName()
	 * @see javax.swing.undo.AbstractUndoableEdit#getPresentationName()
	 */
	public String getUndoPresentationName() {
		return getPresentationName();
	}

	/***************************************************************************
	 * toString
	 **************************************************************************/
	/**
	 * @return R}h̕\߂B
	 */
	public String toString() {
		return getClass().getName() + "[" + paramString() + "]";
	}

	/**
	 * @return R}h̃p[^̕\߂B
	 */
	protected String paramString() {
		return "";
	}

	/***************************************************************************
	 * TuNXʂ̃\bh
	 **************************************************************************/
	protected final NoteApplication getApplication() {
		return reciever;
	}

	/**
	 * ݂̃[hԂB
	 */
	protected final NoteApplicationMode getMode() {
		return reciever.getNote().getCurrentPage().getMode();
	}

	protected final Note getNote() {
		return reciever.getNote();
	}

	protected final Page getCurrentPage() {
		return reciever.getNote().getCurrentPage();
	}

	protected final PictureGroup getEdittingPictureGroup() {
		return this.getCurrentPage().getEdittingPictureGroup();
	}

	protected final TextGroup getEdittingTextGroup() {
		return this.getCurrentPage().getEdittingTextGroup();
	}

	/****
	 * Getter UI
	 ***/
	protected final GroupEditor getEditableGroupEditor(){
		return this.getCurrentPageViewer().getEditableGroupEditor();
	}
	protected final PictureGroupPane getEditablePictureGroupPane(){
		return this.getCurrentPageViewer().getEditablePictureGroupPane();
	}
	protected final TextGroupPane getEditableTextGroupPane(){
		return this.getCurrentPageViewer().getEditableTextGroupPane();
	}
	
	protected final NoteProcessorPane getNoteProcessorPane(){
		return this.reciever.getNoteProcessorPane();
	}
	
	protected final PageViewer getCurrentPageViewer(){
		return getNoteProcessorPane().getCurrentPagePane().getViewer();
	}

	/***
	 * Getter model
	 ***/
	protected final TextGroup createTextGroup() {
		return this.getCurrentPage().createTextGroup(getCurrentPen(), reciever);
	}

	protected final PictureGroup createPictureGroup() {
		return this.getCurrentPage().createPictureGroup();
	}

	protected final void repaint() {
		reciever.repaint();
	}

	protected final RegisteredPictureMap getRegisteredPictures() {
		return reciever.getRegisteredPictures();
	}

	protected final Pen getCurrentPen() {
		return reciever.getPen();
	}

	protected final NoteApplication getReciever() {
		return reciever;
	}
}
