/*
 * Created on 2005/12/18
 *
 * Copyright (c) 2005 Nooto Poject.  All rights reserved.
 */
package note.command;

import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.ClipboardOwner;
import java.awt.datatransfer.Transferable;
import java.awt.event.ActionEvent;
import java.util.List;

import javax.swing.Action;

import note.NoteApplication;
import note.control.NoteApplicationMode;
import note.model.PictureGroup;
import note.model.TransferableGroupData;
import note.viewer.PageViewer;
import note.viewer.TextGroupPane;

/**
 * Class CopyCommand
 * 
 * Nbv{[hփRs[R}hB
 * 
 * @author camei
 * @version $Id: CopyCommand.java,v 1.8 2006/02/06 20:12:33 camei Exp $
 */
public class CopyCommand extends AbstractCommand implements ClipboardOwner {

	/***************************************************************************
	 * 萔
	 **************************************************************************/
	/** Comment for <code>serialVersionUID</code> */
	private static final long serialVersionUID = 1L;

	/***************************************************************************
	 * \bh
	 **************************************************************************/
	/**
	 * RXgN^B
	 * 
	 * @param reciever V[o
	 */
	public CopyCommand(NoteApplication reciever) {
		super(reciever);
	}

	/**
	 * @return N[߂B
	 */
	public Object clone() {
		return new CopyCommand(getApplication());
	}

	/**
	 * @return ̃R}hs\ǂ
	 * @see note.command.AbstractCommand#canExecute()
	 */
	public boolean canExecute() {
		// I͈͂ꍇs\
		NoteApplicationMode mode = getMode();
		if (mode.isGroupEditMode()) {
			return getCurrentPageViewer().hasSelection();
		} else {
			return getEditableGroupEditor().hasSelection();
		}
	}

	/**
	 * @see note.command.AbstractCommand#execute()
	 */
	public void execute() {
		super.execute();

		// I͈͂ɉf[^Rs[
		NoteApplicationMode mode = getMode();
		if (mode.isTextMode()) {// eLXg̓[h̏ꍇ

			// TextAction܂ŃRs[s
			TextGroupPane editor = getEditableTextGroupPane();
			Action cutAction = editor.getActionMap().get("copy");
			ActionEvent e = new ActionEvent(editor,
					ActionEvent.ACTION_PERFORMED, "copy");
			cutAction.actionPerformed(e);

			return;

		} else if (mode.isPictureMode()) {// }`̓[h̏ꍇ
			// I͈͂擾
			PictureGroup pictureGroup = getEdittingPictureGroup();
			PictureGroup selection;
			if (pictureGroup.hasSelection()) {// I͈͂ꍇ
				selection = pictureGroup.getSelection();
			} else {
				// Ȃ
				return;
			}

			// Nbv{[h֑I͈͂Rs[
			Clipboard clipboard = Toolkit.getDefaultToolkit()
					.getSystemClipboard();
			clipboard.setContents(selection, this);

			// debug
			System.out.println("Rs[܂B" + selection.toString());
		} else if (mode.isGroupEditMode()) {// O[vҏW[h̏ꍇ
			// IĂO[vRs[
			PageViewer pageUI = getCurrentPageViewer();
			if (pageUI.hasSelection()) {
				List groupList = pageUI.getSelectedGroupList();
				TransferableGroupData data = new TransferableGroupData(
						groupList);
				Clipboard clipboard = Toolkit.getDefaultToolkit()
						.getSystemClipboard();
				clipboard.setContents(data, this);
			} else {
				return;
			}
		}
	}

	/***************************************************************************
	 * ClipboardOwner ̎
	 **************************************************************************/
	/**
	 * Nbv{[h̓ejꂽƂ̏B
	 */
	public void lostOwnership(Clipboard arg0, Transferable arg1) {
		// Ȃ
	}

	/***************************************************************************
	 * Undo Redo
	 **************************************************************************/
	/*
	 * @see note.command.AbstractCommand#isUndoableEdit()
	 */
	public boolean isUndoableEdit() {
		// s\
		return false;
	}
}
