package note.command;

import javax.swing.undo.CannotRedoException;
import javax.swing.undo.CannotUndoException;

import note.NoteApplication;
import note.control.NoteApplicationMode;
import note.model.Group;
import note.model.PictureGroup;
import note.model.TextGroup;

/**
 * ҏW̃O[v肷R}hB
 * ݎd̂͐}`O[v̂
 */
public class FixGroupCommand extends AbstractCommand {

	/***************************************************************************
	 * 萔
	 **************************************************************************/
	private static final long serialVersionUID = 1L;

	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	// Undo
	private NoteApplicationMode oldMode = null;
	private Group fixedGroup = null;

	/**
	 * RXgN^
	 * 
	 * @param reciever V[o[
	 */
	public FixGroupCommand(NoteApplication reciever) {
		super(reciever);
	}

	/**
	 * @return N[߂B
	 */
	public Object clone() {
		return new FixGroupCommand(getApplication());
	}

	/**
	 * @return ݎs\ǂ
	 * @see note.command.AbstractCommand#isEnabled()
	 */
	public boolean canExecute() {
		// }`̓[h͒̏ꍇAL
		NoteApplicationMode mode = getMode();
		return mode.isPictureMode() && mode.isInputting();
	}

	/**
	 * sB
	 */
	public void execute() {
		super.execute();

		NoteApplicationMode mode = getMode();
		oldMode = (NoteApplicationMode) mode.clone();// Undo̕ۑ
		PictureGroup edittingPictureGroup = getEdittingPictureGroup();

		// ҏW̃IuWFNgm肷
		edittingPictureGroup.getEditor().setEditable(false);
		mode.groupFixed();
		repaint();

		fixedGroup = edittingPictureGroup;// Undo̕ۑ

	}

	/***************************************************************************
	 * Undo Redo
	 **************************************************************************/
	/*
	 * @see note.command.AbstractCommand#isUndoableEdit()
	 */
	public boolean isUndoableEdit() {
		if (fixedGroup != null) {// m肵O[vꍇ
			// \
			return true;
		} else {
			return false;
		}
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#getPresentationName()
	 */
	public String getPresentationName() {
		assert (fixedGroup != null);

		String groupType = "";
		if (fixedGroup instanceof TextGroup) {
			groupType = "eLXgO[v";
		} else if (fixedGroup instanceof PictureGroup) {
			groupType = "}`O[v";
		} else {
			assert false;
		}
		return groupType + "m";
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#redo()
	 */
	public void redo() throws CannotRedoException {
		super.redo();
		execute();
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#undo()
	 */
	public void undo() throws CannotUndoException {
		super.undo();
		getMode().setValue(oldMode);
		
		fixedGroup.getEditor().setEditable(true);
		repaint();
	}

}
