/*
 * Created on 2006/02/05
 *
 * Copyright (c) 2005 Nooto Poject.  All rights reserved.
 */
package note.command;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import javax.swing.undo.CannotRedoException;
import javax.swing.undo.CannotUndoException;

import note.NoteApplication;
import note.model.Group;
import note.model.Page;
import note.viewer.GroupEditor;

/**
 * O[v폜R}hB
 * 
 * @author camei
 * @version $Id: GroupDeleteCommand.java,v 1.1 2006/02/06 20:12:32 camei Exp $
 */
public class GroupDeleteCommand extends AbstractCommand {

	private static final long serialVersionUID = 1L;

	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	private Collection groups = null;// 폜Ώۂ̃O[vB

	// Undo
	private Page updetedPage = null;// 폜XVꂽy[W
	private GroupEditor removedEditableGroup = null;// 폜ꂽҏW̃O[v

	/**
	 * RXgN^B
	 * 
	 * @param reciever NoteApplication
	 * @param groups 폜Ώۂ̃O[v
	 */
	public GroupDeleteCommand(NoteApplication reciever, Collection groups) {
		super(reciever);
		this.groups = groups;
	}

	/*
	 * @see note.command.AbstractCommand#clone()
	 */
	public Object clone() {
		return new GroupDeleteCommand(getApplication(), new ArrayList(groups));
	}

	/**
	 * 폜Ώۂ̃O[vꍇAs\B
	 * 
	 * @see note.command.AbstractCommand#canExecute()
	 */
	public boolean canExecute() {
		return !groups.isEmpty();
	}

	/**
	 * sB
	 */
	public void execute() {
		super.execute();

		// TODO O[vy[WQƂł悤ɂB
		// ̕@ƃy[WHႤꂪiȂǂȊj
		updetedPage = getCurrentPage();// Undo̕ۑ

		// IĂO[v폜
		for (Iterator i = groups.iterator(); i.hasNext();) {
			Group group = (Group) i.next();

			// Undo̕ۑ
			// ҏW̃O[v폜ꍇAL^
			if (group.getEditor().isEditable()) {
				removedEditableGroup = group.getEditor();
			}

			// O[v폜
			updetedPage.removeGroup(group);
		}

		repaint();
	}

	/***************************************************************************
	 * Undo Redo
	 **************************************************************************/

	/**
	 * @return Undo\ȃR}h
	 * @see note.command.AbstractCommand#isUndoableEdit()
	 */
	public boolean isUndoableEdit() {
		return true;
	}

	/**
	 * @see javax.swing.undo.AbstractUndoableEdit#getPresentationName()
	 */
	public String getPresentationName() {
		return "O[v폜";
	}

	/**
	 * @see javax.swing.undo.AbstractUndoableEdit#redo()
	 */
	public void redo() throws CannotRedoException {
		super.redo();
		execute();
	}

	/**
	 * @see javax.swing.undo.AbstractUndoableEdit#undo()
	 */
	public void undo() throws CannotUndoException {
		super.undo();

		// 폜O[v𕜊
		for (Iterator i = groups.iterator(); i.hasNext();) {
			Group group = (Group) i.next();
			updetedPage.addGroup(group);
		}

		// 폜ҏW̃O[vҏW\ɂ
		if (removedEditableGroup != null) {
			removedEditableGroup.setEditable(true);
		}

		repaint();
	}

}
