/*
 * Created on 2006/01/18
 *
 * Copyright (c) 2005 Nooto Poject.  All rights reserved.
 */
package note.command;

import javax.swing.undo.CannotRedoException;
import javax.swing.undo.CannotUndoException;

import note.NoteApplication;
import note.control.NoteApplicationMode;
import note.viewer.GroupEditor;
import note.viewer.PictureGroupPane;
import note.viewer.TextGroupPane;

/**
 * O[v̕ҏWԂύXR}hB
 * Class GroupSetEditableCommand
 *
 * @author camei
 * @version $Id: GroupSetEditableCommand.java,v 1.3 2006/02/06 20:12:32 camei Exp $
 */
public class GroupSetEditableCommand extends AbstractCommand {

	private GroupEditor groupEditor;// ύXO[v
	private boolean isEditable = false;
	
	
	/**
	 * RXgN^B
	 */
	public GroupSetEditableCommand(NoteApplication reciever, GroupEditor groupEditor, boolean isEditable) {
		super(reciever);
		this.groupEditor = groupEditor;
		this.isEditable = isEditable;
	}


	/**
	 * @see note.command.AbstractCommand#clone()
	 */
	public Object clone() {
		return new GroupSetEditableCommand(getApplication(), groupEditor, isEditable);
	}

	public boolean canExecute(){
		NoteApplicationMode mode = getMode();
		return mode.isInputting() && groupEditor.isEditable() != isEditable;
	}
	
	public void execute(){
		super.execute();
			groupEditor.setEditable(isEditable);
		repaint();
	}
	

	/***
	 * Undo Redo
	 ***/
	/**
	 * @see note.command.AbstractCommand#isUndoableEdit()
	 */
	public boolean isUndoableEdit() {
		return true;
	}


	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#getPresentationName()
	 */
	public String getPresentationName() {
		String groupType = "";
		if(groupEditor instanceof TextGroupPane){
			groupType = "eLXgO[v";
		} else if(groupEditor instanceof PictureGroupPane){
			groupType = "}`O[v";
		}
		return groupType + "m";
	}


	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#redo()
	 */
	public void redo() throws CannotRedoException {
		super.redo();
		execute();
	}


	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#undo()
	 */
	public void undo() throws CannotUndoException {
		groupEditor.setEditable(!isEditable);
		repaint();
	}
	
	

}
