package note.command;

import java.awt.Point;
import java.awt.Rectangle;

import javax.swing.undo.CannotRedoException;
import javax.swing.undo.CannotUndoException;

import note.NoteApplication;
import note.RegisteredPictureMap;
import note.control.NoteApplicationMode;
import note.model.Page;
import note.model.Picture;
import note.model.PictureGroup;
import note.model.picture.PictureDesign;
import note.model.picture.PicturePoint;
import note.viewer.PictureGroupPane;
import note.viewer.TextGroupPane;

/**
 * }`͂R}hB
 * 
 * @author camei
 * @version $Id: PictureInputCommand.java,v 1.9 2006/02/06 20:12:32 camei Exp $
 */
public class PictureInputCommand extends AbstractCommand {

	/***************************************************************************
	 * 萔
	 **************************************************************************/
	private static final long serialVersionUID = 1L;

	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	private String pictureName = "Circle";// ͂}`̖O

	// Undo
	private NoteApplicationMode oldMode = null;// JڑȌ
	private PictureGroup createdPictureGroup = null;// V}`O[v
	private PictureGroupPane updatedGroupEditor = null;// XVꂽ}`O[ṽGfB^[
	private Page updatedPage = null;// XVꂽy[W
	private Picture insertedPicture = null;// ͂}`
	private Point oldAnchorPoint = null;// ÕAJ[ʒu
	private PicturePoint oldFocusPoint = null;// ȎI_
	private boolean hasBeenEditablePictureGroup = false;

	/**
	 * RXgN^
	 * 
	 * @param pictureName ͂}`̖O
	 * @param reciever V[o[
	 */
	public PictureInputCommand(String pictureName, NoteApplication reciever) {
		super(reciever);
		this.pictureName = pictureName;
	}

	/**
	 * @return N[߂B
	 */
	public Object clone() {
		return new PictureInputCommand(pictureName, getApplication());
	}

	/**
	 * @return ݎs\
	 * @see note.command.AbstractCommand#canExecute()
	 */
	public boolean canExecute() {
		return true;
	}

	/**
	 * sB
	 */
	public void execute() {
		super.execute();

		RegisteredPictureMap registeredPictureMap = getRegisteredPictures(); // o^Ă}`

		// ͂}`݌v}擾
		PictureDesign pictureDesign = registeredPictureMap
				.getPictureDesign(pictureName);

		// G[
		if (pictureDesign == null) {
			throw new RuntimeException("}`[" + pictureName + "]͓o^Ă܂");
		}

		// [hɂē͕@ςē͂
		NoteApplicationMode mode = getMode();
		oldMode = (NoteApplicationMode) mode.clone();// Undo̕ۑ
		if (mode.isPictureMode()) {// }`̓[h̏ꍇ

			if (mode.isWaitInputting()) {// ͑҂̏ꍇ
				updatedPage = getCurrentPage();// Undo̕ۑ
				oldAnchorPoint = updatedPage.getAnchorPoint();// Undo̕ۑ

				// O[vVK쐬
				createdPictureGroup = createPictureGroup();// Undo̕ۑ

				{// }`
					hasBeenEditablePictureGroup = true;// Undo̕ۑ

					// }`𐶐
					PicturePoint focusPoint = ((PictureGroupPane) createdPictureGroup
							.getEditor()).getFocusPoint();
					Picture picture = pictureDesign.createPicture(focusPoint,
							getCurrentPen());

					// }`ǉ
					createdPictureGroup.addPicture(picture);

					// I_}`̏I_ɐݒ肷
					((PictureGroupPane) createdPictureGroup.getEditor())
							.setFocusPoint(picture.getEndPoint());

				}

				mode.groupUpdated(createdPictureGroup);// O[v̍XVʒm

			} else if (mode.isInputting()) {// ͒̏ꍇ

				{// }`
					updatedGroupEditor = getEditablePictureGroupPane();

					// }`𐶐
					oldFocusPoint = updatedGroupEditor.getFocusPoint();// Undo̕ۑ
					insertedPicture = pictureDesign.createPicture(
							oldFocusPoint, getCurrentPen());// Undo̕ۑ

					// }`ǉ
					PictureGroup pictureGroup = (PictureGroup) updatedGroupEditor
							.getGroup();
					pictureGroup.addPicture(insertedPicture);

					// I_}`̏I_ɐݒ肷
					updatedGroupEditor.setFocusPoint(insertedPicture.getEndPoint());
				}

				mode.groupUpdated(getEdittingPictureGroup());// O[v̍XVʒm
			} else {
				return;
			}

		} else if (mode.isTextMode()) {// eLXg̓[h̏ꍇ

			if (mode.isWaitInputting() || mode.isInputting()) {
				TextGroupPane editor = getEditableTextGroupPane();

				if (editor.hasSelection()) {// I͈͂Lꍇ
					// I͈͂ɉ}`͂

					updatedPage = getCurrentPage();// Undo̕ۑ

					// I`̈쐬
					Rectangle selection = editor.getSelectionBounds();

					{// }`O[vÏ̍_ɐVK쐬

						// }`O[vVK쐬
						Point anchorPoint = getCurrentPageViewer()
								.getAnchorPoint();
						createdPictureGroup = new PictureGroup(
								(int) anchorPoint.getX(), (int) anchorPoint
										.getY());

						// }`O[vړ
						createdPictureGroup.setLocation(selection.x,
								selection.y);
					}

					{// I͈͂ɉ}`
						selection.setLocation(0, 0);// I͈͂}`O[vWɒ
						Picture picture = pictureDesign.createPicture(
								selection, getCurrentPen());// }`𐶐
						createdPictureGroup.addPicture(picture);// }`ǉ
					}

					// O[vy[Wɒǉ
					updatedPage.addGroup(createdPictureGroup);

					// O[vm
					createdPictureGroup.getEditor().setEditable(false);

					System.out.println("I͈͂}`");

				} else {// I͈͂ꍇ
					// AJ[ʒun_ƂĐ}`͂

					// }`O[vVK쐬
					updatedPage = getCurrentPage();
					Point anchorPoint = getCurrentPageViewer().getAnchorPoint();
					createdPictureGroup = new PictureGroup((int) anchorPoint
							.getX(), (int) anchorPoint.getY());

					// O[vy[Wɒǉ
					updatedPage.addGroup(createdPictureGroup);

					// }`
					Picture picture = pictureDesign.createPicture(
							createdPictureGroup.getFocusPoint(),
							getCurrentPen());
					createdPictureGroup.addPicture(picture);

					// O[vm
					createdPictureGroup.getEditor().setEditable(false);
				}
			}
		}
		repaint();
	}

	/***************************************************************************
	 * Undo Redo
	 **************************************************************************/
	/*
	 * @see note.command.AbstractCommand#isUndoableEdit()
	 */
	public boolean isUndoableEdit() {
		// \
		return true;
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#getPresentationName()
	 */
	public String getPresentationName() {
		return pictureName + "̓";
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#isSignificant()
	 */
	public boolean isSignificant() {
		// 1XebvƂĈ
		return true;
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#redo()
	 */
	public void redo() throws CannotRedoException {
		super.redo();

		if (createdPictureGroup != null) {// VK}`O[v}ꍇ
			// ͂}`O[v𕜊
			updatedPage.addGroup(createdPictureGroup);
			if(hasBeenEditablePictureGroup){
				PictureGroupPane editor = (PictureGroupPane)createdPictureGroup.getEditor();
				editor.setEditable(true);
				editor.setFocusPoint(insertedPicture.getEndPoint());
				
			}
		} else if (updatedGroupEditor != null) {// }`}ꍇ
			// }`}
			PictureGroup pictureGroup = (PictureGroup) updatedGroupEditor
					.getGroup();
			insertedPicture.live();
			pictureGroup.addPicture(insertedPicture);
			updatedGroupEditor.setFocusPoint(insertedPicture.getEndPoint());
		}

		repaint();
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#undo()
	 */
	public void undo() throws CannotUndoException {
		super.undo();

		if (oldMode != null) {

			if (createdPictureGroup != null) {// VK쐬}`O[vꍇ

				// VK쐬}`O[v폜
				updatedPage.removeGroup(createdPictureGroup);

				if (oldAnchorPoint != null) {
					// AJ[ʒu߂
					updatedPage.setAnchorLocation(oldAnchorPoint.x,
							oldAnchorPoint.y);
				}
			} else if (insertedPicture != null) {// ҏW̐}`O[vɓ͂}`ꍇ
				// ͂}`폜
				PictureGroup pictureGroup = (PictureGroup) updatedGroupEditor
						.getGroup();
				pictureGroup.remove(insertedPicture);

				// I_߂
				updatedGroupEditor.setFocusPoint(oldFocusPoint);
			}

			// JڑȌԂɖ߂
			getMode().setValue(oldMode);

			repaint();
		}

	}
}
