package note.command;

import java.awt.geom.Point2D;
import java.util.Arrays;

import note.NoteApplication;
import note.control.NoteApplicationMode;
import note.model.Page;
import note.model.PictureGroup;
import note.viewer.PictureGroupPane;

/**
 * I_ړR}h
 * 
 * @author camei
 * @version $Id: TargetPicturePointMoveCommand.java,v 1.1 2005/12/14 12:04:37
 * camei Exp $
 */
public class TargetPicturePointMoveCommand extends AbstractCommand {

	/***************************************************************************
	 * 萔
	 **************************************************************************/
	// ړ萔
	/** ړ萔  */
	public static final int UP = PictureGroupPane.UP;
	/** ړ萔  */
	public static final int DOWN = PictureGroupPane.DOWN;
	/** ړ萔  */
	public static final int LEFT = PictureGroupPane.LEFT;
	/** ړ萔 E */
	public static final int RIGHT = PictureGroupPane.RIGHT;

	private static final long serialVersionUID = 1L;
	private static final int[] ALL_DIRECTION = { UP, DOWN, LEFT, RIGHT };

	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	private int direction = UP;// ^[QbgҏW_ړۂ̐is
	private boolean withSelecting = false;// I͈͂w肵Ȃړ邩

	/***************************************************************************
	 * \bh
	 **************************************************************************/
	/**
	 * RXgN^B
	 * 
	 * @param direction ړ萔
	 * @param reciever V[o[
	 */
	public TargetPicturePointMoveCommand(int direction, NoteApplication reciever) {
		super(reciever);

		if (Arrays.binarySearch(ALL_DIRECTION, direction) != -1) {
			this.direction = direction;
		} else {
			throw new IllegalArgumentException("ړ萔̎w肪s");
		}
	}

	/**
	 * @return N[߂B
	 */
	public Object clone() {
		TargetPicturePointMoveCommand clone = new TargetPicturePointMoveCommand(
				direction, getApplication());
		clone.withSelecting = this.withSelecting;
		return clone;
	}

	/**
	 * @return ݎs\ǂ
	 * @see note.command.AbstractCommand#isEnabled()
	 */
	public boolean canExecute() {
		// }`̓[hœ͒̏ꍇAL
		NoteApplicationMode mode = getMode();
		return mode.isPictureMode() && mode.isInputting();
	}

	/**
	 * sB
	 */
	public void execute() {
		super.execute();

		PictureGroupPane editor = (PictureGroupPane)getEditableGroupEditor();

		// }`O[ṽ^[QbgҏW_ړ
		if (withSelecting) {// IȂ̈ړ̏ꍇ
			editor.moveFocusPointWithSelecting(direction);
		} else {// IȂ̈ړł͂Ȃꍇ
			editor.moveFocusPoint(direction);
		}

		repaint();// ĕ`
	}

	/**
	 * IȂI_ړR}h
	 * 
	 * @author camei
	 * @version $Id: TargetPicturePointMoveCommand.java,v 1.1 2005/12/14
	 * 12:04:37 camei Exp $
	 */
	public static class Selecting extends TargetPicturePointMoveCommand {
		private static final long serialVersionUID = 1L;

		/**
		 * RXgN^
		 * 
		 * @param direction ړ
		 * @param reciever V[o[
		 */
		public Selecting(int direction, NoteApplication reciever) {
			super(direction, reciever);
			super.withSelecting = true;
		}
	}

	/***************************************************************************
	 * Undo Redo
	 **************************************************************************/
	/*
	 * @see note.command.AbstractCommand#isUndoableEdit()
	 */
	public boolean isUndoableEdit() {
		// s\
		return false;
	}
}
