/**
 * 
 */
package note.configuration;

import java.awt.event.KeyEvent;
import java.util.List;

import javax.swing.KeyStroke;

import note.NoteApplication;
import note.command.AbstractCommand;
import note.command.MoveKeyCommand;
import note.command.OpenCommand;
import note.command.PictureDeleteCommand;
import note.command.PrintCommand;
import note.command.SaveCommand;
import note.command.TargetPicturePointMoveCommand;
import note.configuration.element.AbstractFunctionConfigurationElement;
import note.configuration.element.KeyAndFunctionConfigurationElement;
import note.configuration.element.KeyConfigurationElement;
import note.control.KeyCommandMap;

/**
 * 샌x̃L[ݒ
 * 
 * @author camei
 * @version $Id: SemanticsKeyConfiguration.java,v 1.1 2005/11/19 01:49:39 camei
 * Exp $
 */
public class SemanticsKeyConfiguration {

	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	private int moveKeyModifiers;// ړCqL[
	private KeyCommandMap anchorMoveKeyMap;// ړL[}bv
	private KeyCommandMap pictureKeyMap;// }`L[}bv
	private KeyCommandMap functionKeyMap;// t@NVL[}bv
	private KeyCommandMap miscKeyMap;// ̑L[}bv
	private KeyCommandMap keyPressedKeyMap = new KeyCommandMap();
	private KeyCommandMap keyReleasedKeyMap = new KeyCommandMap();

	/***************************************************************************
	 * \bh
	 **************************************************************************/
	/**
	 * _x̃L[ݒ肩lݒ肷B
	 */
	public void setValue(ConceptualKeyConfiguration conceptualKeyConfiguration,
			NoteApplication application) {

		{// AJ[ړL[}bvݒ肷
			List moveKeyConfiguration = conceptualKeyConfiguration
					.getMoveKeyConfigurationList();
			anchorMoveKeyMap = getKeyMapByKeyMapConfiguration(
					moveKeyConfiguration, application);
		}
		{// }`L[}bvݒ肷
			List pictureKeyConfiguration = conceptualKeyConfiguration
					.getPictureKeyConfigurationList();
			pictureKeyMap = getKeyMapByKeyMapConfiguration(
					pictureKeyConfiguration, application);
		}
		{// @\L[}bvݒ肷
			List functionKeyConfiguration = conceptualKeyConfiguration
					.getFunctionKeyConfigurationList();
			functionKeyMap = getKeyMapByKeyMapConfiguration(
					functionKeyConfiguration, application);
		}
		{// ̑L[}bvݒ肷
			List pictureEdittingKeyConfiguration = conceptualKeyConfiguration
					.getPictureEdittingKeyConfigurationList();
			miscKeyMap = getKeyMapByKeyMapConfiguration(
					pictureEdittingKeyConfiguration, application);
		}

		{// ړCqL[ɃAJ[ړԂ̕ύX@\o^
			String keyCodeText = conceptualKeyConfiguration
					.getMoveKeyModifiersText();
			System.out.println("ړL[=" + keyCodeText);

			// ړCqL[@\o^
			AbstractCommand moveKeyPressedFunction = new MoveKeyCommand(
					MoveKeyCommand.PRESSED, application);// @\𐶐
			keyPressedKeyMap.putCommand(KeyStroke.getKeyStroke("pressed " + keyCodeText),
					moveKeyPressedFunction);// Ƃɂ"Cq+Cq"̏ƂĈ

			// ړCqL[𗣂@\o^
			AbstractCommand moveKeyReleasedFunction = new MoveKeyCommand(
					MoveKeyCommand.RELEASED, application);
			keyReleasedKeyMap.putCommand(KeyStroke.getKeyStroke("released " + keyCodeText), moveKeyReleasedFunction);// ɂ"Cq"݂̂̏ƂĈ
		}

		{// TODO R}hmFp̎bo^BXMLݒt@CɈڍs邱ƁB

			// Shift+ɐ}`IR}ho^
			AbstractCommand up = new TargetPicturePointMoveCommand.Selecting(
					TargetPicturePointMoveCommand.UP, application);
			AbstractCommand down = new TargetPicturePointMoveCommand.Selecting(
					TargetPicturePointMoveCommand.DOWN, application);
			AbstractCommand right = new TargetPicturePointMoveCommand.Selecting(
					TargetPicturePointMoveCommand.RIGHT, application);
			AbstractCommand left = new TargetPicturePointMoveCommand.Selecting(
					TargetPicturePointMoveCommand.LEFT, application);
			anchorMoveKeyMap.putCommand(KeyStroke.getKeyStroke("shift UP"), up);
			anchorMoveKeyMap.putCommand(KeyStroke.getKeyStroke("shift DOWN"), down);
			anchorMoveKeyMap.putCommand(KeyStroke.getKeyStroke("shift RIGHT"), right);
			anchorMoveKeyMap.putCommand(KeyStroke.getKeyStroke("shift LEFT"), left);

			// }`폜R}ho^
			AbstractCommand bs = new PictureDeleteCommand(
					PictureDeleteCommand.CONNECT, application);
			pictureKeyMap.putCommand(KeyStroke.getKeyStroke("BACK_SPACE"), bs);

//			// TODO <c> Z[uR}ho^
//			AbstractCommand save = new SaveCommand(application);
//			functionKeyMap.putCommand(KeyStroke.getKeyStroke("ctrl M"), save);
//
//			// TODO I[vR}ho^
//			AbstractCommand open = new OpenCommand(application);
//			functionKeyMap.putCommand(KeyStroke.getKeyStroke("ctrl N"), open);
//			
//			// TODO vgR}ho^
//			AbstractCommand print = new PrintCommand(application);
//			functionKeyMap.putCommand(KeyStroke.getKeyStroke("ctrl P"), print);
			
		}

		// ړCqL[ݒ肷
		moveKeyModifiers = conceptualKeyConfiguration.getMoveKeyModifiers();

	}

	/*
	 * L[@\ݒvfXgAL[@\}bv߂B
	 */
	private KeyCommandMap getKeyMapByKeyMapConfiguration(
			List keyMapConfiguration, NoteApplication application) {

		KeyCommandMap keyFunctinoMap = new KeyCommandMap();// L[@\}bv

		KeyAndFunctionConfigurationElement keyAndFunction;// L[ݒvfƋ@\ݒvf̃Zbg
		KeyConfigurationElement keyElement;// L[ݒvf
		AbstractFunctionConfigurationElement functionElement;// @\ݒvf

		// L[@\ݒvfXgL[@\}bv
		for (int i = 0; i < keyMapConfiguration.size(); i++) {
			keyAndFunction = (KeyAndFunctionConfigurationElement) keyMapConfiguration
					.get(i);

			// L[̕\
			keyElement = keyAndFunction.getKey();
			KeyStroke keyStroke = keyElement.getKeyStroke();

			// @\
			functionElement = keyAndFunction.getFunction();
			AbstractCommand function = functionElement.getFunction(application);

			// L[@\}bvɋ@\o^
			keyFunctinoMap.putCommand(keyStroke, function);
		}

		return keyFunctinoMap;
	}

	/***************************************************************************
	 * Getter & Setter
	 **************************************************************************/
	/**
	 * @return functionKeyMap ߂܂B
	 */
	public KeyCommandMap getFunctionKeyMap() {
		return functionKeyMap;
	}

	/**
	 * @return miscKeyMap ߂܂B
	 */
	public KeyCommandMap getMiscKeyMap() {
		return miscKeyMap;
	}

	/**
	 * @return anchorMoveKeyMap ߂܂B
	 */
	public KeyCommandMap getAnchorMoveKeyMap() {
		return anchorMoveKeyMap;
	}

	/**
	 * @return moveKeyModifiers ߂܂B
	 */
	public int getMoveKeyModifiers() {
		return moveKeyModifiers;
	}

	/**
	 * @return pictureKeyMap ߂܂B
	 */
	public KeyCommandMap getPictureKeyMap() {
		return pictureKeyMap;
	}

	/**
	 * @return keyPressedKeyMap ߂B
	 */
	public KeyCommandMap getKeyPressedKeyMap() {
		return keyPressedKeyMap;
	}

	/**
	 * @return keyReleasedKeyMap ߂B
	 */
	public KeyCommandMap getKeyReleasedKeyMap() {
		return keyReleasedKeyMap;
	}
	
}
