/**
 * 
 */
package note.configuration.element;

import javax.swing.KeyStroke;

import note.control.KeyCommandMap;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * L[ݒvfB
 * 
 * @author camei
 * @version $Id: KeyConfigurationElement.java,v 1.2 2006/01/28 00:13:56 camei Exp $
 */
public class KeyConfigurationElement extends AbstractConfigurationElement {
	/***************************************************************************
	 * 萔
	 **************************************************************************/
	private static final String TAG_NAME = "key";
	private static final String KEY_CODE_ATTRIBUTE = "code";
	private static final String MODIFIERS_ATTRIBUTE = "modifier";

	/***************************************************************************
	 * 
	 **************************************************************************/
	private String keyCode;
	private String modifiers;

	/***************************************************************************
	 * \bh
	 **************************************************************************/
	public String getTagName() {
		return TAG_NAME;
	}

	public AbstractConfigurationElement getNewInstance() {
		return new KeyConfigurationElement();
	}

	public void setValue(Element element) {

		// L[R[hݒ肷
		String keyCodeText = element.getAttribute(KEY_CODE_ATTRIBUTE);
		if (keyCodeText.equals("") == false) {// lݒ肳Ăꍇ
			keyCode = keyCodeText;
		} else {
			// ɃG[
		}

		// CqL[ݒ肷
		this.modifiers = element.getAttribute(MODIFIERS_ATTRIBUTE);

	}

	public Element parseXMLElement(Document document) {
		Element element = document.createElement(TAG_NAME);
		element.setAttribute(KEY_CODE_ATTRIBUTE, keyCode);
		element.setAttribute(MODIFIERS_ATTRIBUTE, modifiers);

		return element;
	}

	/***************************************************************************
	 * Getter & Setter
	 **************************************************************************/

	/**
	 * L[R[hƏCqȂ镶߂<br>
	 * @see KeyStroke.getKeyStroke(String)
	 */
	public KeyStroke getKeyStroke() {
		return KeyStroke.getKeyStroke(modifiers + " " + keyCode);
	}

	/**
	 * @return keyCode ߂܂B
	 */
	public String getKeyCode() {
		return keyCode;
	}

	/**
	 * @return modifiers ߂܂B
	 */
	public String getModifiers() {
		return modifiers;
	}
}
