package note.configuration.element;

import note.NoteApplication;
import note.command.AbstractCommand;
import note.command.PageMoveCommand;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * y[Wړ@\̐ݒvfB
 * 
 * @author camei
 * @version $Id: PageMoveFunctionConfigurationElement.java,v 1.2 2005/12/14 12:04:37 camei Exp $
 */
public class PageMoveFunctionConfigurationElement extends
		AbstractFunctionConfigurationElement {

	/***************************************************************************
	 * 萔
	 **************************************************************************/
	private static final String TAG_NAME = "pagemove";
	private static final String MOVING_TYPE_ATTRIBUTE = "name";
	private static final String PREVIOUS_VALUE = "previous";
	private static final String NEXT_VALUE = "next";
	private static final String INSERT_VALUE = "insert";

	/***************************************************************************
	 * 
	 **************************************************************************/
	private int movingType;// ړ@

	/***************************************************************************
	 * \bh
	 **************************************************************************/
	/*
	 * @see note.configuration.element.AbstractFunctionConfigurationElement#getTagName()
	 */
	public String getTagName() {
		return TAG_NAME;
	}

	public AbstractConfigurationElement getNewInstance() {
		return new PageMoveFunctionConfigurationElement();
	}

	public AbstractCommand getFunction(NoteApplication application) {
		return new PageMoveCommand(movingType, application);
	}

	public void setValue(Element element) {
		String movingTypeText = element.getAttribute(MOVING_TYPE_ATTRIBUTE);

		if (movingTypeText.equals(PREVIOUS_VALUE)) {
			movingType = PageMoveCommand.PREVIOUS;
		} else if (movingTypeText.equals(NEXT_VALUE)) {
			movingType = PageMoveCommand.NEXT;
		} else if (movingTypeText.equals(INSERT_VALUE)) {
			movingType = PageMoveCommand.INSERT;
		}
	}

	public Element parseXMLElement(Document document) {
		Element element = document.createElement(TAG_NAME);
		String movingTypeText = "";

		if (movingType == PageMoveCommand.PREVIOUS) {
			movingTypeText = PREVIOUS_VALUE;
		} else if (movingType == PageMoveCommand.NEXT) {
			movingTypeText = NEXT_VALUE;
		} else if (movingType == PageMoveCommand.INSERT) {
			movingTypeText = INSERT_VALUE;
		}
		element.setAttribute(MOVING_TYPE_ATTRIBUTE, movingTypeText);

		return element;
	}

}