package note.configuration.element;

import java.awt.Color;

import note.NoteApplication;
import note.command.AbstractCommand;
import note.command.PenChangeCommand;
import note.control.Pen;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * yύX@\̐ݒvfB
 * 
 * @author camei
 * @version $Id: PenChangeFunctionConfigurationElement.java,v 1.2 2005/12/14 12:04:37 camei Exp $
 */
public class PenChangeFunctionConfigurationElement extends
		AbstractFunctionConfigurationElement {

	/***************************************************************************
	 * 萔
	 **************************************************************************/
	private static final String TAG_NAME = "penchange";
	private static final String COLOR_VALUE_SEPALTER = ",";
	private static final String LARGE_VALUE = "large";
	private static final String MIDDLE_VALUE = "middle";
	private static final String SMALL_VALUE = "small";
	private static final String FONT_FAMILY_ATTRIBUTE = "fontfamily";
	private static final String COLOR_ATTRIBUTE = "color";
	private static final String SIZE_ATTRIBUTE = "size";

	/***************************************************************************
	 * 
	 **************************************************************************/
	private int size = Pen.UNCHANGE;
	private Color color = null;
	private String fontFamily = null;

	/***************************************************************************
	 * \bh
	 **************************************************************************/
	/*
	 * @see note.configuration.element.AbstractFunctionConfigurationElement#getTagName()
	 */
	public String getTagName() {
		return TAG_NAME;
	}

	public AbstractConfigurationElement getNewInstance() {
		return new PenChangeFunctionConfigurationElement();
	}

	public AbstractCommand getFunction(NoteApplication application) {
		Pen pen = new Pen(color, size, fontFamily);// ύXy̍
		return new PenChangeCommand(pen, application);// yύX@\߂
	}

	public void setValue(Element element) {
		String sizeText = element.getAttribute(SIZE_ATTRIBUTE);
		String colorText = element.getAttribute(COLOR_ATTRIBUTE);
		String fontText = element.getAttribute(FONT_FAMILY_ATTRIBUTE);

		// F̍\͂
		if (colorText.equals("") == false) {// lݒ肳Ăꍇ
			// "r,g,b"\L̍\
			String[] rgb = colorText.split(COLOR_VALUE_SEPALTER);
			int r = Integer.parseInt(rgb[0]);// ύX̐F
			int g = Integer.parseInt(rgb[1]);
			int b = Integer.parseInt(rgb[2]);

			color = new Color(r, g, b);
		}

		// ỹTCY̍\͂
		if (sizeText.equals("") == false) {// TCY̑lݒ肳Ăꍇ
			// TCY\L̍\
			if (sizeText.equals(SMALL_VALUE)) {
				size = Pen.SMALL;
			} else if (sizeText.equals(MIDDLE_VALUE)) {
				size = Pen.MIDDLE;
			} else if (sizeText.equals(LARGE_VALUE)) {
				size = Pen.LARGE;
			}
		}

		// tHg̍\͂
		if (fontText.equals("") == false) {// lݒ肳Ăꍇ
			// ỹtHgݒ
			fontFamily = fontText;
		}

	}

	public Element parseXMLElement(Document document) {
		Element element = document.createElement(TAG_NAME);

		if (color != null) {
			String colorText = color.getRed() + COLOR_VALUE_SEPALTER
					+ color.getGreen() + COLOR_VALUE_SEPALTER + color.getBlue();
			element.setAttribute(COLOR_ATTRIBUTE, colorText);
		}
		if (size != Pen.UNCHANGE) {
			String sizeText;
			if (size == Pen.SMALL) {
				sizeText = SMALL_VALUE;
			} else if (size == Pen.MIDDLE) {
				sizeText = MIDDLE_VALUE;
			} else if (size == Pen.LARGE) {
				sizeText = LARGE_VALUE;
			} else {
				throw new RuntimeException("ỹTCY̐ݒ肪sł");
			}
			element.setAttribute(SIZE_ATTRIBUTE, sizeText);
		}
		return element;
	}
}