/*
 * Created on 2006/01/05
 *
 * Copyright (c) 2005 Nooto Poject.  All rights reserved.
 */
package note.control;

import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;

import javax.swing.Action;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.KeyStroke;

import note.NoteApplication;
import note.command.AbstractCommand;
import note.command.CopyCommand;
import note.command.CutCommand;
import note.command.FixGroupCommand;
import note.command.ModeChangeCommand;
import note.command.OpenCommand;
import note.command.PasteCommand;
import note.command.PictureDeleteCommand;
import note.command.PrintCommand;
import note.command.QuitCommand;
import note.command.SaveAsCommand;
import note.command.SaveCommand;
import note.configuration.KeyConfiguration;
import note.control.GUI.ShowVersionAction;
import note.control.action.NoteAction;
import note.control.action.ShowManualAction;

/**
 * ̂Ɨpj[o[B<br>
 * 
 * @author camei
 * @version $Id: NoteMenuBar.java,v 1.12 2006/02/07 13:23:43 hashiyaman Exp $
 */
public class NoteMenuBar extends JMenuBar {

	/***************************************************************************
	 * 萔
	 **************************************************************************/
	private static final long serialVersionUID = 1L;

	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	private final NoteApplication application;

	/**
	 * RXgN^B
	 * 
	 * @param application NoteApplication
	 * @param keyConfiguration L[ݒ
	 */
	public NoteMenuBar(NoteApplication application,
			KeyConfiguration keyConfiguration) {
		super();

		this.application = application;

		// TODO ANV͂܂Ƃ߂ĂǂɈړĂKv肻B
		// TODO InputMap,ActionMapgĐ悤B
		// TODO ȉcommand null ̓̕R}hsBB

		// t@CANV
		Action openNew = new NoteAction("VK쐬", null);
		Action open = new NoteAction("J", new OpenCommand(application));
		Action save = new NoteAction("ۑ", new SaveCommand(application));
		Action saveAs = new NoteAction("ʖۑ", new SaveAsCommand(application));
		Action print = new NoteAction("", new PrintCommand(application));
		Action quit = new NoteAction("I", new QuitCommand(application));

		// ҏWANV
		Action undo = new NoteAction("ɖ߂", AbstractCommand
				.createUndoCommand(application));
		Action redo = new NoteAction("蒼", AbstractCommand
				.createRedoCommand(application));
		Action cut = new NoteAction("؂", new CutCommand(application));
		Action copy = new NoteAction("Rs[", new CopyCommand(application));
		Action paste = new NoteAction("\t", new PasteCommand(application));
		Action delete = new NoteAction("폜", new PictureDeleteCommand(
				PictureDeleteCommand.NOT_CONNECT, application));
		Action fixPictureGroup = new NoteAction("m", new FixGroupCommand(
				application));

		// [hؑփANV
		Action changeTextMode = new NoteAction("eLXg̓[h",
				new ModeChangeCommand(NoteApplicationMode.TEXT_MODE,
						application));
		Action changePictureMode = new NoteAction("}`̓[h",
				new ModeChangeCommand(NoteApplicationMode.PICTURE_MODE,
						application));

		// ݒANV
		Action configuration = new NoteAction("ݒ", null);

		// wvANV
		Action manual = new ShowManualAction("}jA");
		Action version = new ShowVersionAction("o[W");

		{// t@C
			JMenu file = createMenu("t@C", KeyEvent.VK_F);
			file.add(createMenuItem(openNew, KeyEvent.VK_N));
			file.add(createMenuItem(open, KeyEvent.VK_O));
			file.addSeparator();
			file.add(createMenuItem(save, KeyEvent.VK_S, KeyStroke
					.getKeyStroke(KeyEvent.VK_S, InputEvent.CTRL_MASK)));
			file.add(createMenuItem(saveAs, KeyEvent.VK_A, KeyStroke
					.getKeyStroke(KeyEvent.VK_A, InputEvent.CTRL_MASK
							+ InputEvent.SHIFT_MASK)));
			file.addSeparator();
			file.add(createMenuItem(print, KeyEvent.VK_P, KeyStroke
					.getKeyStroke(KeyEvent.VK_P, InputEvent.CTRL_MASK)));
			file.add(createMenuItem(quit, KeyEvent.VK_Q, KeyStroke
					.getKeyStroke(KeyEvent.VK_W, InputEvent.CTRL_MASK)));
			add(file);
		}

		{// ҏW
			JMenu edit = createMenu("ҏW", KeyEvent.VK_E);

			// bUndoj[
			JMenuItem undoItem = new UndoMenuItem(undo, KeyEvent.VK_E);
			undoItem.setAccelerator(KeyStroke.getKeyStroke("ctrl Z"));
			edit.add(undoItem);

			// bRedoj[
			JMenuItem redoItem = new RedoMenuItem(redo, KeyEvent.VK_R);
			redoItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Y,
					InputEvent.CTRL_MASK));
			edit.add(redoItem);

			edit.addSeparator();
			edit.add(createMenuItem(cut, KeyEvent.VK_T, KeyStroke.getKeyStroke(
					KeyEvent.VK_X, InputEvent.CTRL_MASK)));
			edit.add(createMenuItem(copy, KeyEvent.VK_C, KeyStroke
					.getKeyStroke(KeyEvent.VK_C, InputEvent.CTRL_MASK)));
			edit.add(createMenuItem(paste, KeyEvent.VK_P, KeyStroke
					.getKeyStroke(KeyEvent.VK_V, InputEvent.CTRL_MASK)));

			edit.addSeparator();
			edit.add(createMenuItem(delete, KeyEvent.VK_D, KeyStroke
					.getKeyStroke(KeyEvent.VK_DELETE, 0)));
			edit.add(createMenuItem(fixPictureGroup, KeyEvent.VK_F, KeyStroke
					.getKeyStroke(KeyEvent.VK_ENTER, 0)));

			add(edit);
		}

		{// [hؑ
			JMenu mode = createMenu("[h", KeyEvent.VK_M);
			mode.add(createMenuItem(changeTextMode, KeyEvent.VK_T));
			mode.add(createMenuItem(changePictureMode, KeyEvent.VK_P));
			add(mode);
		}

		{// c[
			JMenu tool = createMenu("c[", KeyEvent.VK_T);
			tool.add(createMenuItem(configuration, KeyEvent.VK_O));
			add(tool);
		}

		{// wv
			JMenu help = createMenu("wv", KeyEvent.VK_H);
			help.add(createMenuItem(manual, KeyEvent.VK_M));
			help.add(createMenuItem(version, KeyEvent.VK_A));
			add(help);
		}

	}

	/*
	 * j[jbNt̃j[
	 */
	private JMenu createMenu(String text, int mnemonic) {
		String menuText = text + "(" + KeyEvent.getKeyText(mnemonic) + ")";// j[̃eLXg
		JMenu menu = new JMenu(menuText);
		menu.setMnemonic(mnemonic);
		return menu;
	}

	/*
	 * j[jbNt̃j[ڂ
	 */
	private JMenuItem createMenuItem(Action action, int mnemonic) {
		String menuName = (String) action.getValue(Action.NAME);
		String menuText;

		// Kvȃj[ڂɑ΂āC"..."t
		// ""邩ǂŔf
		if (menuName.endsWith("")) {
			menuText = menuName.replaceAll("", "") + "("
					+ KeyEvent.getKeyText(mnemonic) + ")" + "...";
		} else {
			menuText = menuName + "(" + KeyEvent.getKeyText(mnemonic) + ")";
		}

		JMenuItem menuItem = new NoteMenuItem(action);
		menuItem.setText(menuText);
		menuItem.setMnemonic(mnemonic);
		return menuItem;
	}

	/*
	 * j[jbNAANZ[^[t̃j[ڂ
	 */
	private JMenuItem createMenuItem(Action action, int mnemonic,
			KeyStroke accelerator) {
		JMenuItem menuItem = createMenuItem(action, mnemonic);
		menuItem.setAccelerator(accelerator);// ANZ[^[L[o^
		return menuItem;
	}

	// bUndoj[
	// TODO @\ActionɈڍsB
	private class UndoMenuItem extends JMenuItem {
		public UndoMenuItem(Action action, int mnemonic) {
			super();
			setAction(action);
			setMnemonic(mnemonic);
			String menuText = action.getValue(Action.NAME) + "("
					+ KeyEvent.getKeyText(mnemonic) + ")";
			setText(menuText);
		}

		public String getText() {
//			setEnabled(isEnable());

			// UndoManageȑԂ\
			String undoText = application.getUndoPresentationName();
			undoText = undoText.replaceAll("ɖ߂", "");// "ɖ߂"dĂ܂̂ō폜
			return super.getText() + " " + undoText;
		}

//		public boolean isEnable() {
//			return application.canUndo();
//		}
	}

	// bRedoj[
	private class RedoMenuItem extends JMenuItem {
		public RedoMenuItem(Action action, int mnemonic) {
			super();
			setAction(action);
			setMnemonic(mnemonic);
			String menuText = action.getValue(Action.NAME) + "("
					+ KeyEvent.getKeyText(mnemonic) + ")";
			setText(menuText);
		}

		public String getText() {
//			setEnabled(isEnable());

			// UndoManageȑԂ\
			String redoText = application.getRedoPresentationName();
			redoText = redoText.replaceAll("Ďs", "");// "Ďs"폜
			return super.getText() + " " + redoText;
		}

//		public boolean isEnable() {
//			return application.canRedo();
//		}
	}

	// TODO j[ڂ̓IȗLA̐ؑւłȂBȂH
	// TODO -> isEnable͂傭傭Ăяo킯ł͂ȂBisEnable悤ȃ^C~OActionXVȂႾ߁B
	private class NoteMenuItem extends JMenuItem {
		public NoteMenuItem(Action action) {
			super(action);
		}

		public boolean isEnable() {
			return getAction().isEnabled();
		}
	}
}
