/*
 * Created on 2005/06/23
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package note.model;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Point;
import java.awt.image.BufferedImage;
import java.io.Serializable;

/**
 * @author kurokiyuta
 * @version $Id: NoteStyle.java,v 1.4 2006/02/09 02:14:29 tajifu Exp $
 */
public class NoteStyle implements Serializable{
	private final int DEFAULT_LINE_HEIGHT = 16;
    private int dpi;
	private int width = 550;
	private int height = 800;
    
	private int lineNumber = 0; //r̐
	private int lineHeight = DEFAULT_LINE_HEIGHT; //r̕
	private int headerHeight = 100; //wb_[̕
	private int footerHeight = 100; //tb^[̕
	private int rightMarginWidth = 20; //E̗]̕
	private int leftMarginWidth = 20; //̗]̕
    
	private Point defaultAnchorPoint = new Point(30, 116); //AJ[̏ʒu
	private Color lineColor = new Color(230, 230, 255); //r̐F
	private Color boldLineColor = new Color(150, 150, 255); //r̐F
	private transient Image backgroundImage; //wi

    /**
     * RXgN^
     */
	public NoteStyle() {
	    setLineHeight(lineHeight);
	}
	
	/**
	 * wi摜
	 */
	public Image createBackgroundImage() {
		if (backgroundImage != null) { //摜ɂ΁C߂
			return backgroundImage;
		
        } else {
			//wi摜p
			BufferedImage image = new BufferedImage(width, height,
					BufferedImage.TYPE_INT_BGR);// 摜p
			Graphics2D g = (Graphics2D) image.getGraphics();

			//wi𔒂œh蕏
			g.setColor(Color.WHITE);
			g.fillRect(0, 0, width, height);

			int begin = this.rightMarginWidth; //1s̎n[
			int end = width - this.rightMarginWidth; //1s̏I[
            
            //wb_[ƃtb^[`悷
			g.setColor(boldLineColor);
			g.drawLine(begin, headerHeight, end, headerHeight);// wb_[
			g.drawLine(begin, height - footerHeight, end, height - footerHeight);// tb^[

			//šr`悷
			g.setColor(lineColor);
			for (int i = 1; i < lineNumber; i++) {
				int y = headerHeight + (lineHeight * i);
				g.drawLine(begin, y, end, y);
			}
			backgroundImage = image;
			return image;
		}
	}
	
	//ɌrKvȂꍇ
//	public Image createBackgroundImageForPrint() {
//		BufferedImage image = new BufferedImage(width, height,
//				BufferedImage.TYPE_INT_BGR);// 摜p
//		Graphics2D g = (Graphics2D) image.getGraphics();
		//wi𔒂œh蕏
//		g.setColor(Color.WHITE);
//		g.fillRect(0, 0, width, height);
//		return image;
//	}
    
    /**************************************************************************
     * Getter & Setter
     **************************************************************************/

    public int getDpi() {
        return dpi;
    }

    public void setDpi(int dpi) {
        this.dpi = dpi;
    }

    public int getHeight() {
        return height;
    }

    public void setHeight(int height) {
        this.height = height;
    }

    public int getLineHeight() {
        return lineHeight;
    }

    public void setLineHeight(int lineHeight) {
        this.lineHeight = lineHeight;
        lineNumber = (height - headerHeight - footerHeight) / lineHeight;        
    }

    public int getLineNumber() {
        return lineNumber;
    }

    public void setLineNumber(int lineNumber) {
        this.lineNumber = lineNumber;
        lineHeight = (height - headerHeight - footerHeight) / lineNumber;
    }

    public int getWidth() {
        return width;
    }

    public void setWidth(int width) {
        this.width = width;
    }

    public int getFooterHeight() {
        return footerHeight;
    }

    public void setFooterHeight(int footerHeight) {
        this.footerHeight = footerHeight;
    }

    public int getHeaderHeight() {
        return headerHeight;
    }

    public void setHeaderHeight(int headerHeight) {
        this.headerHeight = headerHeight;
    }

    public int getRightMarginWidth() {
        return rightMarginWidth;
    }

    public void setRightMarginWidth(int sideMarginWidth) {
        this.rightMarginWidth = sideMarginWidth;
    }
    
    public int getLeftMarginWidth() {
        return leftMarginWidth;
    }

    public void setLeftMarginWidth(int leftMarginWidth) {
        this.leftMarginWidth = leftMarginWidth;
    }

    public Point getDefaultAnchorPoint() {
        return defaultAnchorPoint;
    }

    public void setDefaultAnchorPoint(Point defaultAnchorPoint) {
        this.defaultAnchorPoint = defaultAnchorPoint;
    }    
}