package note.model;

import java.awt.Point;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.swing.event.UndoableEditListener;

import note.control.NoteApplicationMode;
import note.control.Pen;
import note.viewer.GroupEditor;
import note.viewer.PageViewer;

/**
 * y[WB
 * 
 * @author camei
 * @version $Id: Page.java,v 1.15 2006/02/06 20:13:02 camei Exp $
 */
public class Page implements Serializable {

	/***************************************************************************
	 * 萔
	 **************************************************************************/
	private static final long serialVersionUID = 1L;

	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	// private Point anchorPoint; // AJ[̍W
	// private NoteApplicationMode mode = new NoteApplicationMode();// ݂̃[h
	private transient PageViewer pageUI;// XVʒm郊Xi[

	// Group֘A
	private List pictureGroupList = new ArrayList(); // }`O[vXg
	private List textGroupList = new ArrayList(); // eLXgO[vXg

	// private TextGroup edittingTextGroup;// ҏW̃eLXgO[v
	// private PictureGroup edittingPictureGroup;// ҏW̐}`O[v

	/***************************************************************************
	 * \bh
	 **************************************************************************/
	/**
	 * RXgN^B
	 */
	public Page() {
	}

	/**
	 * V}`O[vB<br>
	 * 쐬O[vǉB<br>
	 * 쐬O[vҏWɂB<br>
	 * TODO ̃\bh2ȏ̂ƂĂBB܂̓\bhς
	 */
	public PictureGroup createPictureGroup() {

		Point anchorPoint = pageUI.getAnchorPoint();

		// }`O[v쐬
		PictureGroup pictureGroup = new PictureGroup((int) anchorPoint.getX(),
				(int) anchorPoint.getY());

		// ݂̃y[Wɐ}`ǉ
		addGroup(pictureGroup);

		// ҏW̃O[vɐݒ肷B
		pictureGroup.getEditor().setEditable(true);

		return pictureGroup;
	}

	/**
	 * VeLXgO[vB<br>
	 * 쐬O[vǉB<br>
	 * 쐬O[vҏWɂB<br>
	 * TODO ̃\bh2ȏ̂ƂĂBB܂̓\bhς
	 */
	public TextGroup createTextGroup(Pen pen,
			UndoableEditListener undoableEditListener) {
		Point anchorPoint = pageUI.getAnchorPoint();

		// eLXgO[v
		TextGroup textGroup = new TextGroup((int) anchorPoint.getX(),
				(int) anchorPoint.getY());

		// ݂̃y[WɃeLXgO[vǉ
		addGroup(textGroup);

		// ҏW̃O[vɐݒ肷B
		textGroup.getEditor().setEditable(true);

		return textGroup;
	}

	/**
	 * O[vǉB
	 * 
	 * @param group ǉO[v
	 */
	public void addGroup(Group group) {
		// O[v̎ނƂɕۊǂ
		if (group instanceof PictureGroup) {
			this.pictureGroupList.add(group);
		} else if (group instanceof TextGroup) {
			this.textGroupList.add(group);
		} else {
			throw new IllegalArgumentException("O[v̌^sł");
		}

		// O[v̒ǉXi[ɒʒm
		pageUI.groupAdded(group);
	}

	/**
	 * O[v폜B
	 * 
	 * @param group 폜O[v
	 * @return 폜ɐǂ
	 */
	public boolean removeGroup(Group group) {
		boolean isSuccessRemoved;

		// O[vXg폜
		if (group instanceof PictureGroup) {
			isSuccessRemoved = this.pictureGroupList.remove(group);
		} else if (group instanceof TextGroup) {
			isSuccessRemoved = this.textGroupList.remove(group);
		} else {
			return false;
		}

		// O[v̒ǉXi[ɒʒm
		pageUI.groupRemoved(group);

		return isSuccessRemoved;
	}

	// /**
	// * O[vҏW\ԂɂB
	// *
	// * @param group ҏW\ԂɂO[v
	// */
	// public void setEditableGroup(Group group) {
	// if (group instanceof PictureGroup && pictureGroupList.contains(group)) {
	// group.edit();
	// edittingPictureGroup = (PictureGroup) group;
	// } else if (group instanceof TextGroup && textGroupList.contains(group)) {
	// group.edit();
	// edittingTextGroup = (TextGroup) group;
	// pageUI.groupEdited(edittingTextGroup);
	// } else {
	// throw new RuntimeException("y[Wɑ݂ȂO[vҏW\ɂ悤Ƃ܂");
	// }
	// }

	/**
	 * AJ[|Cg̈ʒuw肵ʒuɈړB<br>
	 * TODO ҏW̃O[vS\悤ɂB
	 * 
	 * @param x AJ[ʒuxW
	 * @param y AJ[ʒuyW
	 */
	public void setAnchorLocation(int x, int y) {
		pageUI.setAnchorLocation(x, y);
		// // AJ[|Cgy[W̊OɏoȂ悤ɂ(ݎgĂȂ)
		// // Point2D includedPagePoint = getIncludedPagePoint(new Point(x, y));
		// // x = (int) includedPagePoint.getX();
		// // y = (int) includedPagePoint.getY();
		//
		// // AJ[|Cgړ
		// anchorPoint.setLocation(x, y);
		//
		// // AJ[|Cgړʒm
		// pageUI.anchorPointMoved();
	}

	/**
	 * AJ[|Cg̈ʒuw肵ʒuɈړB<br>
	 * 
	 * @param point AJ[ʒu
	 */
	public void setAnchorLocation(Point point) {
		setAnchorLocation((int) point.getX(), (int) point.getY());
	}

	/**
	 * y[WXVꂽƂʒm郊Xi[ǉ
	 */
	public void addPageChangedListener(PageViewer pageUI) {
		this.pageUI = pageUI;
	}

	// public List getContainedPicturesByBounds(Rectangle area) {
	// List pictures = new ArrayList();
	// for (Iterator i = pictureGroupList.iterator(); i.hasNext();) {
	// PictureGroup pictureGroup = (PictureGroup) i.next();
	// pictures.addAll(pictureGroup.getContainedElementsByBounds(area));
	// }
	// return pictures;
	// }
	//
	// public Picture getContainedPictureByPoint(int x, int y) {
	// Picture picture;
	// for (Iterator i = pictureGroupList.iterator(); i.hasNext();) {
	// PictureGroup pictureGroup = (PictureGroup) i.next();
	// picture = pictureGroup.getContainedElementsByPoint(x, y);
	// if (picture != null) {
	// return picture;
	// }
	// }
	// return null;
	// }

	/***************************************************************************
	 * GroupChangedListener ̎
	 **************************************************************************/
	// public void fixedUpdate(Group group) {
	//
	// }
	// public void editedUpdate(Group group) {
	//
	// // ҏW\O[vݒ肷
	// if (group instanceof PictureGroup) {
	// // ݂̕ҏW\O[vҏWs\ɂ
	// if (edittingPictureGroup != null) {
	// edittingPictureGroup.fix();
	// }
	// edittingPictureGroup = (PictureGroup)group;
	// } else if (group instanceof TextGroup) {
	// // ݂̕ҏW\O[vҏWs\ɂ
	// if (edittingTextGroup != null) {
	// edittingTextGroup.fix();
	// }
	// edittingTextGroup = (TextGroup)group;
	// } else {
	// throw new RuntimeException("O[v̎w肪sł");
	// }
	// }
	// public void changedUpdate(Group group) {
	// mode.groupUpdated(group);
	// }
	//
	// public void movedUpdate(Group group) {
	//
	// }
	/***************************************************************************
	 * Getter & Setter
	 **************************************************************************/

	public Point getAnchorPoint() {
		return pageUI.getAnchorPoint();
	}

	public NoteApplicationMode getMode() {
		return pageUI.getMode();
	}

	public Group getEdittingGroup() {
		GroupEditor groupEditor = pageUI.getEditableGroupEditor();
		if (groupEditor != null) {
			return groupEditor.getGroup();
		} else {
			return null;
		}
	}

	public PictureGroup getEdittingPictureGroup() {
		Group group = getEdittingGroup();
		if (group != null) {
			return (PictureGroup) group;
		} else {
			return null;
		}
	}

	public TextGroup getEdittingTextGroup() {
		Group group = getEdittingGroup();
		if (group != null) {
			return (TextGroup) group;
		} else {
			return null;
		}
	}

	/**
	 * @return }`O[ṽXg
	 */
	public List getPictureGroupList() {
		return new ArrayList(pictureGroupList);
	}

	/**
	 * @return eLXgO[ṽXg
	 */
	public List getTextGroupList() {
		return new ArrayList(textGroupList);
	}

	/**
	 * @return SẴO[ṽXg
	 */
	public List getGroupList() {
		List groupList = new ArrayList(textGroupList);
		groupList.addAll(pictureGroupList);
		return groupList;
	}
}
