/*
 * Created on 2006/01/19
 *
 * Copyright (c) 2005 Nooto Poject.  All rights reserved.
 */
package note.model.picture;

import java.awt.Insets;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.geom.AffineTransform;
import java.awt.geom.GeneralPath;
import java.awt.geom.Point2D;
import java.io.Serializable;

import note.control.Pen;
import note.model.Picture;

/**
 * Class PictureDesign }`̐݌vB
 * 
 * @author camei
 * @version $Id: PictureDesign.java,v 1.1 2006/01/25 11:56:16 camei Exp $
 */
public class PictureDesign implements Serializable{

	/***************************************************************************
	 * 萔
	 **************************************************************************/
	private static final long serialVersionUID = 1L;
	private static final Insets DEFAULT_SELECTION_INSETS = new Insets(5, 5, 5,
			5);// ݒ̑ΉI͈
	private static final int DIMENSION_4_BEZIER = 4;

	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	private String name; // }`̖O
	private Point2D[] points; // SĂ̓_
	private int[][] lines; // SĂ̐i͑SĂ̓_indexŎw肳j
	private int beginPos = -1;// SĂ̓_̎n_index
	private int endPos = -1;// SĂ̓_̏I_index
	private int[] controlsPos;// SĂ̓_̑_index
	private Rectangle selection;// I͈͂͂ꍇ̐}`̑I͈͋`̈ȋI͈͂Ɉv悤ɐ}`ό`j
//	private AffineTransform rotate = null;// n_ƏI_xɂ邽߂̉]W
	private double theta;

	/**
	 * RXgN^B
	 */
	protected PictureDesign() {
	}

	/**
	 * RXgN^B<br>
	 * }`̈ʐ݌v@ɏ]Đ}`i݌v}ԁjB
	 * 
	 * @param name }`̖O
	 * @param points }`ɎgSĂ̓_
	 * @param lines }`ɎgSẴxWFȐ̓_index(begin, ctrl1, ctrl2, end)
	 * @param beginPos pointsn_ɐݒ肷_index
	 * @param endPos pointsI_ɐݒ肷_index
	 * @param controlsPos points瑀_ɐݒ肷SĂ̓_index
	 */
	public PictureDesign(String name, Point2D[] points, int[][] lines,
			int beginPos, int endPos, int[] controlsPos) {
		// I͈͂w肹ɃCX^X
		this(name, points, lines, beginPos, endPos, controlsPos, null);

		{// fBtHg̑ΉI͈͂쐬

			// }`̋`̈vZ
			int top = (int) points[0].getY();
			int bottom = (int) points[0].getY();
			int left = (int) points[0].getX();
			int right = (int) points[0].getX();

			for (int i = 0; i < points.length; i++) {
				if (points[i].getX() < left) {
					left = (int) points[i].getX();
				} else if (points[i].getX() > right) {
					right = (int) points[i].getX();
				}
				if (points[i].getY() < top) {
					top = (int) points[i].getY();
				} else if (points[i].getY() > bottom) {
					bottom = (int) points[i].getY();
				}
			}

			// ΉÏk
			left += DEFAULT_SELECTION_INSETS.left;
			right -= DEFAULT_SELECTION_INSETS.right;
			top += DEFAULT_SELECTION_INSETS.top;
			bottom -= DEFAULT_SELECTION_INSETS.bottom;

			this.selection = new Rectangle(left, top, right - left, bottom
					- top);
		}
	}

	/**
	 * RXgN^B<br>
	 * ΉI͈͂w肵Đ}`i݌v}ԁjB
	 * 
	 * @param name }`̖O
	 * @param points }`ɎgSĂ̓_
	 * @param lines }`ɎgSẴxWFȐ̓_index(begin, ctrl1, ctrl2, end)
	 * @param beginPos pointsn_ɐݒ肷_index
	 * @param endPos pointsI_ɐݒ肷_index
	 * @param controlsPos points瑀_ɐݒ肷SĂ̓_index
	 * @param selection I͈͂͂ꍇ̑ΉI͈
	 */
	public PictureDesign(String name, Point2D[] points, int[][] lines,
			int beginPos, int endPos, int[] controlsPos, Rectangle selection) {
		this.name = name;

		// SĂ̓_
		this.points = new Point2D[points.length];
		System.arraycopy(points, 0, this.points, 0, points.length);

		// i2xWFȐj
		this.lines = new int[lines.length][DIMENSION_4_BEZIER];
		for (int i = 0; i < lines.length; i++) {
			System.arraycopy(lines[i], 0, this.lines[i], 0, DIMENSION_4_BEZIER);
		}

		// n_̈ʒu
		this.beginPos = beginPos;

		// I_̈ʒu
		this.endPos = endPos;

		// _̈ʒu
		this.controlsPos = new int[controlsPos.length];
		System.arraycopy(controlsPos, 0, this.controlsPos, 0,
				controlsPos.length);

		// ΉI͈͂
		this.selection = selection;

		{// (n_ I_)xƕsɂȂ悤ɉ]ÂƂ̉]WۑĂ
			Point2D begin = points[beginPos];// n_b
			Point2D end = points[endPos];// I_e
			double bex = end.getX() - begin.getX();// bex
			double bey = end.getY() - begin.getY();// bey

			if (bey == 0) {// xƕsłȂꍇ
				// ]W߂
				double theta = Math.atan2(bey, bex);// bẻ]p
				AffineTransform rotate = AffineTransform
						.getRotateInstance(theta);

				// (n_ I_)xƕsɂȂ悤ɐ݌v}]
				rotate.transform(points, 0, points, 0, points.length);

				// sɂ邽߂ɉ]pxۑ
				this.theta = -theta;
			}
		}
	}

	/***************************************************************************
	 * 
	 **************************************************************************/
	/**
	 * ̐݌v}g債V}`݌v}߂B
	 * 
	 * @param name VO
	 * @param sx g嗦x
	 * @param sy g嗦y
	 * @return g債V}`݌v}
	 */
	public PictureDesign cloneWithScale(String name, double sx, double sy) {
		// Rs[쐬
		PictureDesign clone = (PictureDesign) this.clone();
		clone.name = name;// Oݒ

		// Rs[g
		AffineTransform scale = AffineTransform.getScaleInstance(sx, sy);
		scale.transform(points, 0, clone.points, 0, points.length);

		// Rs[Ԃ
		return clone;
	}

	/**
	 * ̐݌v}]Rs[߂B
	 * 
	 * @param name VO
	 * @param theta ]px
	 * @return ]V}`݌v}
	 */
	public PictureDesign cloneWithRotate(String name, double theta) {
		// Rs[쐬
		PictureDesign clone = (PictureDesign) this.clone();
		clone.name = name;// Oݒ

		// Rs[]
//		AffineTransform scale = AffineTransform.getRotateInstance(theta);
//		scale.transform(points, 0, clone.points, 0, points.length);
		clone.theta = theta;

		// Rs[Ԃ
		return clone;
	}

	/***************************************************************************
	 * clone
	 **************************************************************************/
	/**
	 * ݌viK̐}`̃Rs[𐶐
	 * 
	 * @return ꂽ݌viK̐}`
	 */
	public Object clone() {
		// ݌v_Rs[
		Point2D[] copyPoints = new Point2D[points.length];
		for (int i = 0; i < points.length; i++) {
			copyPoints[i] = new Point((Point) points[i]);
		}

		// ݌v_Ǝn_AI_A_indexAΉI͈͂Rs[𐶐
		PictureDesign clone = new PictureDesign(this.name, copyPoints,
				this.lines, this.beginPos, this.endPos, this.controlsPos,
				new Rectangle(selection));

		// Rs[Ԃ
		return clone;
	}

	/***************************************************************************
	 * createPicture
	 **************************************************************************/
	/**
	 * ̃fUC}`𐶐B
	 * 
	 * @param begin n_
	 * @param pen y
	 * @return VPicture
	 */
	public final Picture createPicture(PicturePoint begin, Pen pen) {
		Picture picture = createPicture();

		// }`̎n_ݒ肵ď
		picture.initializeForStandard(begin);

		// yɏ]Đ}`̐Fw肷
		picture.setColor(pen.getColor());

		// yɏ]Đ}`̑傫w肷ig傷j
		picture.scale(pen.getPictureSize(), pen.getPictureSize());
		
		// ]Wݒ肷
		picture.rotate(theta);

		return picture;
	}

	/**
	 * ̃fUC`͂}`𐶐B
	 * @param rectangle ͂`̈
	 * @param pen y
	 * @return VPicture
	 */
	public final Picture createPicture(Rectangle rectangle, Pen pen) {
		Picture picture = createPicture();

		// }`̎n_ƑI͈͂ݒ肵ď
		picture.initializedForSelectionBounds(rectangle.x, rectangle.y,
				rectangle.width, rectangle.height);

		// yɏ]Đ}`̐Fw肷
		picture.setColor(pen.getColor());

		return picture;
	}
	
	/**
	 * @return ̐݌v}ɑΉ}`𐶐B
	 */
	protected Picture createPicture() {
		return new Picture(this);
	}

	/***************************************************************************
	 * Getter & Setter
	 **************************************************************************/

	/**
	 * @return }`Shape
	 */
	public Shape getShape() {
		GeneralPath path = new GeneralPath();
		for (int i = 0; i < lines.length; i++) {
			// ixWFȁj1{pXɒǉ
			path.moveTo((float) points[lines[i][0]].getX(),
					(float) points[lines[i][0]].getY());
			path.curveTo((float) points[lines[i][1]].getX(),
					(float) points[lines[i][1]].getY(),
					(float) points[lines[i][2]].getX(),
					(float) points[lines[i][2]].getY(),
					(float) points[lines[i][3]].getX(),
					(float) points[lines[i][3]].getY());
		}
		return path;
	}

	/**
	 * @return name
	 */
	public String getName() {
		return name;
	}

	/**
	 * name ݒ肷B
	 * 
	 * @param name name
	 */
	protected void setName(String name) {
		this.name = name;
	}

	/**
	 * @return selection
	 */
	public Rectangle getSelection() {
		return new Rectangle(selection);
	}

	/**
	 * selection ݒ肷B
	 * 
	 * @param selection selection
	 */
	protected void setSelection(Rectangle selection) {
		this.selection = selection;
	}

	/**
	 * @return points
	 */
	public Point2D[] getPoints() {
		return points;
	}

	/**
	 * points ݒ肷B
	 * 
	 * @param points points
	 */
	protected void setPoints(Point2D[] points) {
		this.points = points;
	}

	/**
	 * @return begin
	 */
	public Point2D getBegin() {
		return points[beginPos];
	}

	/**
	 * @return controls
	 */
	public Point2D[] getControls() {
		Point2D[] controls = new Point2D[controlsPos.length];
		for (int i = 0; i < controlsPos.length; i++) {
			controls[i] = points[controlsPos[i]];
		}
		return controls;
	}

	/**
	 * @return end
	 */
	public Point2D getEnd() {
		return points[endPos];
	}

	/**
	 * beginPos ݒ肷B
	 * 
	 * @param beginPos beginPos
	 */
	protected void setBeginPos(int beginPos) {
		this.beginPos = beginPos;
	}

	/**
	 * controlsPos ݒ肷B
	 * 
	 * @param controlsPos controlsPos
	 */
	protected void setControlsPos(int[] controlsPos) {
		this.controlsPos = controlsPos;
	}

	/**
	 * endPos ݒ肷B
	 * 
	 * @param endPos endPos
	 */
	protected void setEndPos(int endPos) {
		this.endPos = endPos;
	}

	/**
	 * lines ݒ肷B
	 * 
	 * @param lines lines
	 */
	protected void setLines(int[][] lines) {
		this.lines = lines;
	}

}
