package note.model.picture;

import java.awt.geom.Point2D;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import note.model.Picture;

/**
 * }`̑_\B<br>
 * WPicture̕`̈ɑ΂鑊΍Wŕ\B<br>
 * 
 * @author camei
 * @version &Id:&
 * @date 2005/06/11
 */
public class PicturePoint extends Point2D implements Cloneable, Serializable {
	/***************************************************************************
	 * 
	 **************************************************************************/
	private double x;
	private double y;
	private double ox; // 1stepOxW
	private double oy; // 1stepOyW

	private Picture parentPicture = null;// ̓_̐evf̐}`i̓_𑀍_EI_ƂĎ}`j
	private Set childPictures = new HashSet();// ̓_̎qvf̐}`Bi̓_n_ƂĎ}`j

	// <<view>>
	private Set holders = new HashSet(); // ̓_ۗLSĂ̐}`

	/***************************************************************************
	 * \bh
	 **************************************************************************/
	/**
	 * RXgN^B<br>
	 * w肳ꂽWŏB
	 * 
	 * @param point
	 */
	public PicturePoint(Point2D point) {
		this.x = point.getX();
		this.y = point.getY();
	}

	/***************************************************************************
	 * clone
	 **************************************************************************/
	/**
	 * ̐}`_̃Rs[߂B<br>
	 * ۗL}`ւ̎QƂAe̓Rs[ȂB
	 * @return ̐}`_̃Rs[߂B
	 */
	public Object clone() {
		// WRs[
		PicturePoint clone = new PicturePoint(this);
		return clone;
	}

	/***************************************************************************
	 * }`o^֘A
	 **************************************************************************/
	/**
	 * ̓_̐e}`o^B
	 */
	public void addParent(Picture picture) {
		parentPicture = picture;
		holders.add(picture);
	}

	/**
	 * ̓_̎q}`o^B
	 */
	public void addChild(Picture picture) {
		childPictures.add(picture);
		holders.add(picture);
	}

	/**
	 * o^Ă}`폜B
	 */
	public boolean removeHolder(Picture picture) {
		if (holders.contains(picture)) {
			// o^폜
			if (parentPicture == picture) {
				parentPicture = null;
			} else if (childPictures.contains(picture)) {
				childPictures.remove(picture);
			}
			holders.remove(picture);

			return true;
		} else {
			return false;
		}
	}

	/**
	 * ̓_ҏWꂽƂCtiʒmHjB <br>
	 * ҏWړɌĂяoB
	 */
	public void fireEdittingMove() {
		fireHolders();
	}

	/*
	 * ۗL}`ɁA_ړꂽƂʒm
	 */
	private void fireHolders() {
		// SĂholderɈړCxgʒm
		for (Iterator iter = holders.iterator(); iter.hasNext();) {
			Picture holder = (Picture) iter.next();
			holder.editPointMoved(this);
		}
	}

	/***************************************************************************
	 * Point2D̃I[o[Ch
	 **************************************************************************/
	/**
	 * ʒuw肷
	 */
	public void setLocation(Point2D point) {
		setLocation(point.getX(), point.getY());
	}

	/**
	 * ʒuw肷
	 */
	public void setLocation(double x, double y) {
		// ύXO̍Wۑ
		this.ox = this.x;
		this.oy = this.y;

		// WύX
		this.x = x;
		this.y = y;
	}

	/**
	 * ړ
	 */
	public void translate(double dx, double dy) {
		setLocation(this.x + dx, this.y + dy);
	}

	/***************************************************************************
	 * toString ֘A
	 **************************************************************************/
	public String toString() {
		return getClass().getName() + "[(" + x + "," + y + ")]";
	}

	/***************************************************************************
	 * Getter & Setter
	 **************************************************************************/
	public double getX() {
		return this.x;
	}

	public double getY() {
		return this.y;
	}

	public double getOldX() {
		return this.ox;
	}

	public double getOldY() {
		return this.oy;
	}

	public Point2D getOldPoint() {
		return new Point2D.Double(this.getOldX(), this.getOldY());
	}

	public Picture getParentPicture() {
		return parentPicture;
	}

	public List getChildPictures() {
		return new ArrayList(childPictures);
	}

	/**
	 * @return holderList ߂B
	 */
	public List getHolderList() {
		return new ArrayList(holders);
	}

}
