/**
 * 
 */
package note.viewer;

import java.awt.Color;
import java.awt.Component;
import java.awt.Frame;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Toolkit;
import java.awt.image.BufferedImage;
import java.awt.image.ImageObserver;
import java.awt.image.MemoryImageSource;
import java.awt.image.PixelGrabber;
import java.util.HashMap;

import note.control.NoteApplicationMode;
import note.control.Pen;

/**
 * AJ[̉摜@\B<br>
 * VOgB
 * 
 * @author camei
 * @version $Id: AnchorImageProducer.java,v 1.6 2006/02/06 20:12:36 camei Exp $
 */
public class AnchorImageProducer {
	/***************************************************************************
	 * 萔
	 **************************************************************************/
	// 摜TCY
	public static final int IMAGE_WIDTH = 66;// AJ[摜̕
	public static final int IMAGE_HEIGHT = 66;// AJ[摜̍

	// 摜̃|CeBOW
	public static final int POINTING_X = 33;
	public static final int POINTING_Y = 33;

	// AJ[摜̃t@CpX
	private static final String ANCHOR_IMAGE_PATH = "resources/img/anchorImage/";
	private static final String ANCHOR_EDIT_IMAGE = ANCHOR_IMAGE_PATH
			+ "anchor-edit.gif";
	private static final String ANCHOR_MOVING_STATE_IMAGE = ANCHOR_IMAGE_PATH
			+ "anchor-movingState.gif";
	private static final String ANCHOR_PICTURE_EDITTING_IMAGE = ANCHOR_IMAGE_PATH
			+ "anchor-picture-editting.gif";
	private static final String ANCHOR_PICTURE_LARGE_IMAGE = ANCHOR_IMAGE_PATH
			+ "anchor-picture-large.gif";
	private static final String ANCHOR_PICTURE_MIDDLE_IMAGE = ANCHOR_IMAGE_PATH
			+ "anchor-picture-middle.gif";
	private static final String ANCHOR_PICTURE_SMALL_IMAGE = ANCHOR_IMAGE_PATH
			+ "anchor-picture-small.gif";
	private static final String ANCHOR_TEXT_LARGE_IMAGE = ANCHOR_IMAGE_PATH
			+ "anchor-text-large.gif";
	private static final String ANCHOR_TEXT_MIDDLE_IMAGE = ANCHOR_IMAGE_PATH
			+ "anchor-text-middle.gif";
	private static final String ANCHOR_TEXT_SMALL_IMAGE = ANCHOR_IMAGE_PATH
			+ "anchor-text-small.gif";

	private static final int OPACITY_MIN = 10; //sxŏl
	private static final int OPACITY_MAX = 255; //sxől
	
	private static final Component DAMMY_COMPONENT = new Component() {
	};// MediaTrackerɓn߂̃_~[R|[lg

	/***************************************************************************
	 * 
	 **************************************************************************/
	private static AnchorImageProducer instance;// CX^X
	private HashMap coloredImages = new HashMap();// FύX摜̃LbV

	// AJ[摜֘A
	private MediaTracker tracker;

	// AJ[摜
	private Image imgAnchorEdit = null;
	private Image imgAnchorPictureEditting = null;
	private Image imgAnchorPictureLarge = null;
	private Image imgAnchorPictureMiddle = null;
	private Image imgAnchorPictureSmall = null;
	private Image imgAnchorTextLarge = null;
	private Image imgAnchorTextMiddle = null;
	private Image imgAnchorTextSmall = null;

	private Image imgAnchorMovingState = null;// ړ

	/***************************************************************************
	 * \bh
	 **************************************************************************/
	/*
	 * RXgN^
	 */
	private AnchorImageProducer() {
		// 摜ǂݍ
		initializeAnchorImages();
	}

	/**
	 * AnchorImageProducer̃CX^X߂B
	 */
	public static AnchorImageProducer getInstance() {
		if (instance == null) {// ̃\bh߂ČĂяoꍇ
			instance = new AnchorImageProducer();// CX^X𐶐
		}

		return instance;
	}

	/**
	 * w肳ꂽyƃ[hɉAJ[̉摜߂B
	 */
	public Image getImage(Pen currentPen, NoteApplicationMode mode) {

		Image img = null;// AJ[摜

		// y̏Ԃɂĉ摜ς
		if (mode.isTextMode()) { // ̓[h
			 if (currentPen.isTextLarge()) { // y̑傫LARGEȂ
				img = imgAnchorTextLarge;
			} else if (currentPen.isTextMiddle()) {// y̑傫MIDDLEȂ
				img = imgAnchorTextMiddle;
			} else if (currentPen.isTextSmall()) {// y̑傫SMALLȂ
				img = imgAnchorTextSmall;
			}

		} else if (mode.isPictureMode()) {// }`̓[hȂ
			if (currentPen.isPictureLarge()) {// y̑傫LARGEȂ
				img = imgAnchorPictureLarge;
			} else if (currentPen.isPictureMiddle()) {// y̑傫MIDDLEȂ
				img = imgAnchorPictureMiddle;
			} else if (currentPen.isPictureSmall()) {// y̑傫SMALLȂ
				img = imgAnchorPictureSmall;
			}
			if (mode.isInputting() && mode.isAnchorMoveKeyPressed()) {// ҏWȂ
				img = imgAnchorPictureEditting;
			}
		} else if (mode.isGroupEditMode()){// O[vҏW[h̏ꍇ
			img = imgAnchorEdit;
		}

		// y̐Fɉĉ摜ς
		img = getChangedImageByColor(img, currentPen.getColor());

		return img;
	}

	/*
	 * AJ[摜ǂݍ
	 */
	private void initializeAnchorImages() {

		// 摜ǂݍ
		tracker = new MediaTracker(DAMMY_COMPONENT);// _~[̓NXw肵MediaTracker𐶐
		imgAnchorEdit = getImageByFilePath(ANCHOR_EDIT_IMAGE);
		imgAnchorMovingState = getImageByFilePath(ANCHOR_MOVING_STATE_IMAGE);
		imgAnchorPictureEditting = getImageByFilePath(ANCHOR_PICTURE_EDITTING_IMAGE);
		imgAnchorPictureLarge = getImageByFilePath(ANCHOR_PICTURE_LARGE_IMAGE);
		imgAnchorPictureMiddle = getImageByFilePath(ANCHOR_PICTURE_MIDDLE_IMAGE);
		imgAnchorPictureSmall = getImageByFilePath(ANCHOR_PICTURE_SMALL_IMAGE);
		imgAnchorTextLarge = getImageByFilePath(ANCHOR_TEXT_LARGE_IMAGE);
		imgAnchorTextMiddle = getImageByFilePath(ANCHOR_TEXT_MIDDLE_IMAGE);
		imgAnchorTextSmall = getImageByFilePath(ANCHOR_TEXT_SMALL_IMAGE);

		// 摜̓ǂݍ݂I܂őҋ@
		try {
			tracker.waitForAll();
		} catch (InterruptedException e1) {
			e1.printStackTrace();
		}
	}

	/*
	 * t@C摜ǂݍ
	 */
	private Image getImageByFilePath(String filePath) {
		// 摜ǂݍ
		Toolkit toolkit = Toolkit.getDefaultToolkit();
		Image image = toolkit.getImage(ClassLoader.getSystemResource(filePath));

		// MediaTrackerɓo^
		tracker.addImage(image, 1);// D揇ʂ͈ꗥw肷
		return image;
	}

	/***************************************************************************
	 * 摜̐FύX֘A\bh
	 **************************************************************************/
	/*
	 * w肳ꂽFɕύX摜߂B
	 */
	private Image getChangedImageByColor(Image image, Color color) {
		// LbV邩ǂׂ
		String key = getColoringImageKey(image, color);
		if (coloredImages.containsKey(key)) {// LbVꍇ
			// LbVꂽ摜߂
			return (Image) coloredImages.get(key);

		} else {// LbVꍇ
			// VɐFύX摜pӂĖ߂
			Image colored = changeColor(image, color);// 摜̐FύX
			coloredImages.put(key, colored);// ύX摜LbVɓo^
			return colored;// ύX摜߂
		}
	}

	/*
	 * 摜̐FύXĖ߂
	 */
	private Image changeColor(Image image, Color color) {
		//C[WsNZɕ
		Image changeColorImage;
		int width = image.getWidth(null);
		int height = image.getHeight(null);
		int[] pixels = new int[width * height];// image̊esNZ߂z
		
		PixelGrabber pixelGrabber = new PixelGrabber(image, 0, 0, width, height, pixels, 0, width);
		try {
			pixelGrabber.grabPixels();
		} catch (InterruptedException ie) {
			System.err.println("interrupted waiting for pixels");
			System.exit(1);
		}
		
		// nꂽFɉāC摜̊esNZ̐FύX
		for (int i = 0; i < pixels.length; i++) {
			if (isBlack(pixels[i])) {
				pixels[i] = color.getRGB();
			}
		}
		
		// sNZC[W쐬
		MemoryImageSource source = new MemoryImageSource(width, height, pixels, 0, width);
		Toolkit toolkit = Toolkit.getDefaultToolkit();
		changeColorImage = toolkit.createImage(source);
		
		return changeColorImage;
	}
	
	/*
	 * Ɏw肳ꂽsNZrbgVtgC̐Fsȍł邩ǂԂ
	 */
	private boolean isBlack(int pixel) {
		int alpha = (pixel >> 24) & 0xff;
		int red = (pixel >> 16) & 0xff;
		int green = (pixel >> 8) & 0xff;
		int blue = (pixel) & 0xff;
		
		return (red <= OPACITY_MIN && green <= OPACITY_MIN && blue <= OPACITY_MIN)
				&& alpha == OPACITY_MAX;
	}

	/*
	 * 摜ƐF̃ZbgӂɌ߂L[߂B
	 */
	private String getColoringImageKey(Image image, Color color) {
		return Integer.toString(image.hashCode()) + color.toString();
	}

	/***************************************************************************
	 * Getter & Setter
	 **************************************************************************/

	/**
	 * @return ړԂ̉摜
	 */
	public Image getMovingStateImage() {
		return imgAnchorMovingState;
	}
}
