/*
 * Created on 2006/01/10
 *
 * Copyright (c) 2005 Nooto Poject.  All rights reserved.
 */
package note.command;

import java.awt.event.ActionEvent;
import java.util.Iterator;
import java.util.List;

import javax.swing.Action;
import javax.swing.undo.CannotRedoException;
import javax.swing.undo.CannotUndoException;

import note.NoteApplication;
import note.control.NoteApplicationMode;
import note.model.Group;
import note.model.Page;
import note.viewer.PageViewer;
import note.viewer.TextGroupPane;

/**
 * @author camei
 * @version $Id: CutCommand.java,v 1.3 2006/02/06 20:12:33 camei Exp $
 */
public class CutCommand extends AbstractCommand {

	/***************************************************************************
	 * 萔
	 **************************************************************************/
	private static final long serialVersionUID = 1L;

	/***************************************************************************
	 * ϐ
	 **************************************************************************/

	// Undo
	private AbstractCommand deleteCommand = null;// 폜R}h
	private boolean hasCutPicture = false;
	private boolean hasCutText = false;
	private boolean hasCutGroup = false;

	/**
	 * RXgN^B
	 * 
	 * @param reciever V[o
	 */
	public CutCommand(NoteApplication reciever) {
		super(reciever);
	}

	/**
	 * @return N[߂B
	 */
	public Object clone() {
		return new CutCommand(getApplication());
	}

	/**
	 * @return ̃R}hs\ǂ
	 * @see note.command.AbstractCommand#canExecute()
	 */
	public boolean canExecute() {
		// I͈͂ꍇs\
		NoteApplicationMode mode = getMode();
		if (mode.isGroupEditMode()) {
			return getCurrentPageViewer().hasSelection();
		} else {
			return getEditableGroupEditor().hasSelection();
		}
	}

	/**
	 * @see note.command.AbstractCommand#execute()
	 */
	public void execute() {
		super.execute();

		NoteApplicationMode mode = getMode();

		if (mode.isTextMode()) {// eLXg̓[h̏ꍇ
			// TextAction܂ŃJbgs
			TextGroupPane editor = getEditableTextGroupPane();
			Action cutAction = editor.getActionMap().get("cut");
			ActionEvent e = new ActionEvent(editor,
					ActionEvent.ACTION_PERFORMED, "cut");
			cutAction.actionPerformed(e);

			// ԑJ
			mode.groupUpdated(getEdittingTextGroup());

			hasCutText = true;// Undo̕ۑ

		} else {
			// I͈͂Rs[
			AbstractCommand copy = new CopyCommand(getApplication());
			copy.execute();

			// I͈͂폜
			if (mode.isGroupEditMode()) {// O[vҏW̏ꍇ
				// IĂO[v폜
				PageViewer pageUI = getCurrentPageViewer();
				List selection = pageUI.getSelectedGroupList();
				deleteCommand = new GroupDeleteCommand(getApplication(),
						selection);
				if (deleteCommand.canExecute()) {
					deleteCommand.execute();
					hasCutGroup = true;// Undo̕ۑ
				}

			} else if (mode.isPictureMode()) {// }`̓[h̏ꍇ
				// I͈͂̐}`폜
				deleteCommand = new PictureDeleteCommand(
						PictureDeleteCommand.NOT_CONNECT, getApplication());
				if (deleteCommand.canExecute()) {
					deleteCommand.execute();
					hasCutPicture = true;// Undo̕ۑ
				}

			} else {
				throw new RuntimeException("[hs");
			}

			repaint();
		}
	}

	/*
	 * @see note.command.AbstractCommand#paramString()
	 */
	protected String paramString() {
		return "";
	}

	/***************************************************************************
	 * Undo Redo
	 **************************************************************************/
	/*
	 * @see note.command.AbstractCommand#isUndoableEdit()
	 */
	public boolean isUndoableEdit() {
		if (hasCutText) {
			return false;
		} else if (hasCutPicture || hasCutGroup) {
			return deleteCommand.isUndoableEdit();
		} else {
			throw new RuntimeException("sʂs");
		}
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#getPresentationName()
	 */
	public String getPresentationName() {
		if (hasCutText) {
			throw new RuntimeException("̃R}hUndoManagerɐς܂ĂȂ͂");
		} else if (hasCutPicture) {
			return deleteCommand.getPresentationName();
		} else if (hasCutGroup) {
			return deleteCommand.getPresentationName();
		} else {
			throw new RuntimeException("R}hs̎s");
		}
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#redo()
	 */
	public void redo() throws CannotRedoException {
		super.redo();

		if (hasCutText) {
			throw new RuntimeException("eLXgJbgꍇ͂̃R}hłRedos");
		} else if (hasCutPicture || hasCutGroup) {
			deleteCommand.redo();
		}
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#undo()
	 */
	public void undo() throws CannotUndoException {
		super.undo();

		if (hasCutText) {
			throw new RuntimeException("eLXgJbgꍇ͂̃R}hłUndos");
		} else if (hasCutPicture || hasCutGroup) {
			deleteCommand.undo();
		}
	}

}
