package note.command;

import javax.swing.undo.CannotRedoException;
import javax.swing.undo.CannotUndoException;

import note.NoteApplication;
import note.model.Note;
import note.model.Page;

/**
 * y[Wړ@\
 * 
 * @author camei
 * @version $Id: PageMoveCommand.java,v 1.8 2006/02/03 22:29:56 camei Exp $
 */
public class PageMoveCommand extends AbstractCommand {
	/***************************************************************************
	 * 萔
	 **************************************************************************/
	private static final long serialVersionUID = 1L;
	// ړ@
	/** Õy[WɈړ */
	public static final int PREVIOUS = 1;
	/** ̃y[WɈړ */
	public static final int NEXT = 2;
	/** ݕ\Ăy[WԍɐVy[W} */
	public static final int INSERT = 3;// 

	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	private int movingType;// ړ@

	// Undo
	private Page oldPage = null;
	private Page insertedPage = null;

	/***************************************************************************
	 * \bh
	 **************************************************************************/
	/**
	 * RXgN^
	 * 
	 * @param movingType ړ@
	 * @param reciever reciever
	 */
	public PageMoveCommand(int movingType, NoteApplication reciever) {
		super(reciever);
		this.movingType = movingType;
	}

	/**
	 * @return N[߂B
	 */
	public Object clone() {
		return new PageMoveCommand(movingType, getApplication());
	}

	/**
	 * @return ݎs\
	 * @see note.command.AbstractCommand#canExecute()
	 */
	public boolean canExecute() {
		return true;
	}

	
	/**
	 * sB
	 */
	public void execute() {
		super.execute();

		oldPage = getCurrentPage();

		// ړ@ɉy[Wړs
		if (movingType == PREVIOUS) {
			getNote().movePreviousPage();

		} else if (movingType == NEXT) {
			getNote().moveNextPage();
		} else if (movingType == INSERT) {
			insertedPage = getNote().insertAndMovePage();
		}
		
		repaint();// FIXME ̌ĂяoȂƃy[WړƂɕ\ȂȂBs
	}

	/*
	 * @see note.command.AbstractCommand#paramString()
	 */
	protected String paramString() {
		String typeText;
		switch (movingType) {
		case PREVIOUS:
			typeText = "previous";
			break;
		case NEXT:
			typeText = "next";
			break;
		case INSERT:
			typeText = "insert";
			break;
		default:
			typeText = "error";
		}
		return "type=" + typeText;
	}

	/***************************************************************************
	 * Undo Redo
	 **************************************************************************/
	/*
	 * @see note.command.AbstractCommand#isUndoableEdit()
	 */
	public boolean isUndoableEdit() {
		// \
		return true;
	}
	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#getPresentationName()
	 */
	public String getPresentationName() {
		return getMoveingTypeText();
	}

	/*
	 * y[Wړ@̃eLXg߂B
	 */
	private String getMoveingTypeText() {
		switch (movingType) {
		case PREVIOUS:
			return "Õy[W";
		case NEXT:
			return "̃y[W";
		case INSERT:
			return "y[W}";
		default:
			return "";
		}
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#redo()
	 */
	public void redo() throws CannotRedoException {
		super.redo();
		execute();
	}

	/*
	 * @see javax.swing.undo.AbstractUndoableEdit#undo()
	 */
	public void undo() throws CannotUndoException {
		super.undo();

		Note note = getNote();

		// }y[W폜
		if (insertedPage != null) {
			note.removePage(insertedPage);
		}

		// ړÕy[Wɖ߂
		note.movePage(oldPage);
	}
}
